<?php
/*$Id: standard_template.php,v 1.6 2008/10/17 10:13:35 devincen Exp $
 --------------------------------------------------------------------------
                            Gazie - Gestione Azienda
    Copyright (C) 2004-2008 - Antonio De Vincentiis Montesilvano (PE)
                                (www.devincentiis.it)
                        <http://gazie.sourceforge.net>
 --------------------------------------------------------------------------
    Questo programma e` free software;   e` lecito redistribuirlo  e/o
    modificarlo secondo i  termini della Licenza Pubblica Generica GNU
    come e` pubblicata dalla Free Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.

    Questo programma  e` distribuito nella speranza  che sia utile, ma
    SENZA   ALCUNA GARANZIA; senza  neppure  la  garanzia implicita di
    NEGOZIABILITA` o di  APPLICABILITA` PER UN  PARTICOLARE SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.

    Ognuno dovrebbe avere   ricevuto una copia  della Licenza Pubblica
    Generica GNU insieme a   questo programma; in caso  contrario,  si
    scriva   alla   Free  Software Foundation,  Inc.,   59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA Stati Uniti.
 --------------------------------------------------------------------------
*/
require_once('../../library/tcpdf/tcpdf.php');

class Standard_template extends TCPDF
{
    public function setVars($azienda,$title=false,$luogo_data=1,$n_page=true)
    {
       $this->title = $title;
       $this->logo=$azienda['image'];
       $this->n_page=$n_page;
       $this->intesta1 = $azienda['ragso1'].' '.$azienda['ragso2'];
       $this->intesta2 = $azienda['indspe'].' '.sprintf("%05d",$azienda['capspe']).' '.$azienda['citspe'].' ('.$azienda['prospe'].')';
       $this->intesta3 = 'Tel.'.$azienda['telefo'].' C.F. '.$azienda['codfis'].' P.I. '.$azienda['pariva'];
       $this->intesta4 = $azienda['e_mail'];
       if ($luogo_data === 1) { // se viene passato a 1 stampo luogo_data di systema
          $this->luogo = $azienda['citspe'].", lì ".date("d ").ucfirst(strftime("%B", mktime (0,0,0,date("m")))).date(" Y");
       }  elseif(!empty($luogo_data)) {  // opp. uso quello passato
          $this->luogo = $luogo_data;
       }  else {  // altrimenti non lo stampo
          $this->luogo = '';
       }
       $this->SetCreator(PDF_CREATOR);
       $this->SetTitle($this->title);
       $this->SetAuthor($this->intesta1.' '.PDF_AUTHOR);
       $this->SetHeaderMargin(7);
       $this->SetTopMargin(44);
       $this->SetFooterMargin(23);
       $this->StartPageGroup();
       $this->SetFillColor(hexdec(substr($azienda['colore'],0,2)),hexdec(substr($azienda['colore'],2,2)),hexdec(substr($azienda['colore'],4,2)));
    }

    public function setCover($cover_data=false)
    {
        $this->cover = $cover_data;
    }

    public function setTopCarryBar($top_carry_bar=false)
    {
        $this->top_carry_bar = $top_carry_bar;
    }

    public function setBotCarryBar($bot_carry_bar=false)
    {
        $this->bot_carry_bar = $bot_carry_bar;
    }

    public function Header()
    {
       if (isset($this->cover)) { // se viene passata la copertina
           $this->MemImage($this->logo,80,80,40,0);
           $this->SetFont('freesans','',18);
           $this->SetXY(10,130);
           $this->Cell(190,6,$this->intesta1,0,2,'C');
           $this->SetFont('freesans','',12);
           $this->Cell(190,6,$this->intesta2,0,2,'C');
           $this->Cell(190,6,$this->intesta3,0,2,'C');
           $this->SetXY(55,160);
           $this->SetFont('freesans','',30);
           $this->MultiCell(100,16,$this->cover,1,'C',1);
       } else {
          $this->MemImage($this->logo,15,8,30,0);
          $this->Cell(40,4);
          $this->SetFont('freeserif','B',12);
          $this->Cell(118,5,$this->intesta1,0,0,'L');
          $this->SetFont('freesans','',9);
          if ($this->n_page === 1) { // se viene passato a 1 stampo luogo_data di systema
             $this->Cell(38,5,'Pagina '.$this->getGroupPageNo().' di '.$this->getPageGroupAlias(),0,1,'R');
          }  elseif(is_array($this->n_page) and isset($this->n_page['year'])) {  // se  un array contenente l'anno
             $page = $this->getGroupPageNo()+ $this->n_page['ini_page'] - 1 ;
             $this->Cell(38,5,$this->n_page['year'].'/'.$page,0,1,'R');
          }  elseif(is_string($this->n_page)) {  // opp. uso quello passato
             $this->Cell(38,5,$this->n_page,0,1,'R');
          }  else {  // altrimenti non lo stampo
             $this->Cell(38,5,'',0,1,'R');
          }
          $this->Cell(40,4);
          $this->Cell(130,4,$this->intesta2,0,2,'L');
          $this->Cell(130,4,$this->intesta3,0,2,'L');
          $this->Cell(118,4,$this->intesta4,0,0,'L');
          $this->Cell(38,4,$this->luogo,0,1,'R');
          if (isset($this->title)) {
             $this->Ln(4);
             $this->Cell(40,4);
             $this->SetFont('freesans','B',12);
             $this->Cell(150,5,$this->title,1,1,'L',1);
          } else {
             $this->Cell(1,5,'',0,1);
          }
          $this->Ln(6);
          if (isset($this->top_carry_bar) and is_array($this->top_carry_bar) ) { // se viene passato l'array della barra di riporto
             if (isset($this->top_carry_bar[0]['font'])) {
                $this->SetFont('freesans','',intval($this->top_carry_bar[0]['font']));
             } else {
                $this->SetFont('freesans','',10);
             }
             foreach ($this->top_carry_bar as $value){
                   $this->Cell($value['lenght'],5,$value['name'],$value['frame'],0,'R',$value['fill']);
             }
             $this->Cell(1,5,'',0,1);
          } elseif(is_string($this->top_carry_bar)) {  // opp. uso quello passato
             $this->Cell(186,5,$this->top_carry_bar,0,1,'C');
          }
       }
    }

    public function Footer()
    {
       if (isset($this->cover)) { // se viene passata la copertina
           unset($this->cover);
       } else {
       if (isset($this->bot_carry_bar) and is_array($this->bot_carry_bar) ) { // se viene passato l'array della barra di riporto
          if (isset($this->bot_carry_bar[0]['font'])) {
             $this->SetFont('freesans','',intval($this->bot_carry_bar[0]['font']));
          } else {
             $this->SetFont('freesans','',10);
          }
          foreach ($this->bot_carry_bar as $value){
                   $this->Cell($value['lenght'],5,$value['name'],$value['frame'],0,'R',$value['fill']);
          }
          $this->Cell(1,5,'',0,1);
       }  elseif(is_string($this->bot_carry_bar)) {  // opp. uso quello passato
          $this->Cell(186,5,$this->bot_carry_bar,0,1,'C');
       }
          $this->Ln(4);
          $this->SetFont('freesans','',8);
          $this->MultiCell(190+$this->PorL['diff'],4,$this->intesta1.' '.$this->intesta2.' '.$this->intesta3.' '.$this->intesta4.' ',0,'C',0);
    }
    }

}
?>