<?php
 /* $Id: template.php,v 1.2 2008/10/13 15:18:58 devincen Exp $
 --------------------------------------------------------------------------
                            Gazie - Gestione Azienda
    Copyright (C) 2004-2008 - Antonio De Vincentiis Montesilvano (PE)
                                (www.devincentiis.it)
                        <http://gazie.sourceforge.net>
 --------------------------------------------------------------------------
    Questo programma e` free software;   e` lecito redistribuirlo  e/o
    modificarlo secondo i  termini della Licenza Pubblica Generica GNU
    come e` pubblicata dalla Free Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.

    Questo programma  e` distribuito nella speranza  che sia utile, ma
    SENZA   ALCUNA GARANZIA; senza  neppure  la  garanzia implicita di
    NEGOZIABILITA` o di  APPLICABILITA` PER UN  PARTICOLARE SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.

    Ognuno dovrebbe avere   ricevuto una copia  della Licenza Pubblica
    Generica GNU insieme a   questo programma; in caso  contrario,  si
    scriva   alla   Free  Software Foundation,  Inc.,   59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA Stati Uniti.
 --------------------------------------------------------------------------
*/

require_once('../../library/tcpdf/tcpdf.php');

class Template extends TCPDF
{
    function setVars(&$docVars,$Template='')
    {
        $this->docVars =& $docVars;
        $this->gaz_path = '../../';
        $this->rigbro = $docVars->gTables['rigbro'];
        $this->aliiva = $docVars->gTables['aliiva'];
        $this->tesdoc = $docVars->tesdoc;
        $this->testat = $docVars->testat;
        $this->emissione = $docVars->emissione;
        $this->emissioneddt = $docVars->emissioneddt;
        $this->pagame = $docVars->pagame;
        $this->banapp = $docVars->banapp;
        $this->banacc = $docVars->banacc;
        $this->logo = $docVars->logo;
        $this->intesta1 = $docVars->intesta1;
        $this->intesta1bis = $docVars->intesta1bis;
        $this->intesta2 = $docVars->intesta2;
        $this->intesta3 = $docVars->intesta3.$docVars->intesta4;
        $this->intesta4 = $docVars->codici;
        $this->colore = $docVars->colore;
        $this->decimal_quantity = $docVars->decimal_quantity;
        $this->decimal_price = $docVars->decimal_price;
        $this->perbollo = $docVars->perbollo;
        $this->cliente1 = $docVars->cliente1;
        $this->cliente2 = $docVars->cliente2;
        $this->cliente3 = $docVars->cliente3;
        $this->cliente4 = $docVars->cliente4;  // CAP, Citt, Provincia
        $this->cliente5 = $docVars->cliente5;  // P.IVA e C.F.
        $this->agente = $docVars->name_agente;
        $this->destinazione = $docVars->destinazione;
        $this->clientSedeLegale = '';
        if (!empty ($docVars->clientSedeLegale)) {
                     foreach($docVars->clientSedeLegale as $value) {
                         $this->clientSedeLegale .= $value.' ';
                     }
        }
        $this->c_Attenzione = $docVars->c_Attenzione;
        $this->min = $docVars->min;
        $this->ora = $docVars->ora;
        $this->day = $docVars->day;
        $this->month = $docVars->month;
        $this->year = $docVars->year;

        $this->tottraspo = 0.00;
        if ($Template == 'DDT' and $this->tesdoc['tipdoc'] == 'FAD') {
           $this->tipdoc = 'Documento di Trasporto n.'.$this->emissioneddt;
        } elseif ($this->tesdoc['tipdoc'] == 'FAD') {
            $this->tipdoc = 'Fattura differita N.'.$this->emissione;
            $this->destinazione = '';
        } elseif ($this->tesdoc['tipdoc'] == 'FAI') {
            $this->tipdoc = 'Fattura immediata N.'.$this->emissione;
        } elseif ($this->tesdoc['tipdoc'] == 'FND') {
            $this->tipdoc = 'Nota di debito N.'.$this->emissione;
        } elseif ($this->tesdoc['tipdoc'] == 'FNC') {
            $this->tipdoc = 'Nota di credito N.'.$this->emissione;
        } elseif ($this->tesdoc['tipdoc'] == 'DDR') {
           $this->tipdoc = 'D.d.T. per Reso  n.'.$this->emissioneddt;
        } elseif ($this->tesdoc['tipdoc'] == 'DDL') {
           $this->tipdoc = 'D.d.T. c/lavorazione n.'.$this->emissioneddt;
        } elseif ($this->tesdoc['tipdoc'] == 'DDT') {
           $this->tipdoc = 'Documento di Trasporto n.'.$this->emissioneddt;
        } elseif ($this->tesdoc['tipdoc'] == 'VPR') {
           $this->tipdoc = 'Preventivo a Cliente n.'.$this->tesdoc['numdoc'].' del '.substr($this->tesdoc['datemi'],8,2).' '.strftime("%B", mktime (0,0,0,substr($this->tesdoc['datemi'],5,2))).' '.substr($this->tesdoc['datemi'],0,4);;
        } elseif ($this->tesdoc['tipdoc'] == 'VOR') {
           $this->tipdoc = "Conferma d'Ordine da Cliente n.".$this->tesdoc['numdoc'].' del '.substr($this->tesdoc['datemi'],8,2).' '.strftime("%B", mktime (0,0,0,substr($this->tesdoc['datemi'],5,2))).' '.substr($this->tesdoc['datemi'],0,4);;
        } elseif ($this->tesdoc['tipdoc'] == 'AOR') {
           $this->tipdoc = 'Ordine a fornitore n.'.$this->tesdoc['numdoc'].' del '.substr($this->tesdoc['datemi'],8,2).' '.strftime("%B", mktime (0,0,0,substr($this->tesdoc['datemi'],5,2))).' '.substr($this->tesdoc['datemi'],0,4);
        } elseif ($this->tesdoc['tipdoc'] == 'APR') {
           $this->tipdoc = 'RICHIESTA DI PREVENTIVO n.'.$this->tesdoc['numdoc'].' del '.substr($this->tesdoc['datemi'],8,2).' '.strftime("%B", mktime (0,0,0,substr($this->tesdoc['datemi'],5,2))).' '.substr($this->tesdoc['datemi'],0,4);
        } elseif ($this->tesdoc['tipdoc'] == 'AFA') {
           $this->tipdoc = "Ricevuta Fattura d'acquisto n. ".$this->tesdoc['numfat'].' del '.substr($this->tesdoc['datfat'],8,2).' '.strftime("%B", mktime (0,0,0,substr($this->tesdoc['datfat'],5,2))).' '.substr($this->tesdoc['datfat'],0,4);
        } elseif ($this->tesdoc['tipdoc'] == 'AFC') {
           $this->tipdoc = "Ricevuta Nota Credito n. ".$this->tesdoc['imball'].' del '.substr($this->tesdoc['datfat'],8,2).' '.strftime("%B", mktime (0,0,0,substr($this->tesdoc['datfat'],5,2))).' '.substr($this->tesdoc['datfat'],0,4);
        } elseif ($this->tesdoc['tipdoc'] == 'LET') {
           $this->tipdoc = "Lettera n. ".$this->tesdoc['numdoc'].' del '.substr($this->tesdoc['datemi'],8,2).' '.strftime("%B", mktime (0,0,0,substr($this->tesdoc['datemi'],5,2))).' '.substr($this->tesdoc['datemi'],0,4);
           $this->topline = 'yes';
        } elseif ($this->tesdoc['tipdoc'] == 'NOP') {
           $this->tipdoc = $this->tesdoc['imball'];
        } else {
           $this->tipdoc = '';
        }
    }

    function Header()
    {
        $this->SetFillColor(hexdec(substr($this->colore,0,2)),hexdec(substr($this->colore,2,2)),hexdec(substr($this->colore,4,2)));
        $this->SetFont('freeserif','B',14);
        $this->Cell(130,6,$this->intesta1,0,1,'L');
        $this->SetFont('freesans','',8);
        $interlinea = 14;
        if (!empty($this->intesta1bis))  {
           $this->Cell(130,4,$this->intesta1bis,0,2,'L');
           $interlinea = 10;
        }
        $this->Cell(130,4,$this->intesta2,0,2,'L');
        $this->Cell(130,4,$this->intesta3,0,2,'L');
        $this->Cell(130,4,$this->intesta4,0,0,'L');
        $this->MemImage($this->logo,140,5,40,0);
        $this->Line(0,93,3,93); //questa marca la linea d'aiuto per la piegatura del documento
        $this->Line(0,143,3,143); //questa marca la linea d'aiuto per la foratura del documento
        $this->Ln($interlinea);
        $this->SetFont('freesans','',11);
        $this->Cell(110,5,$this->tipdoc,1,1,'L',1);
        if ($this->tesdoc['tipdoc'] == 'NOP') {
           $this->Cell(30,5);
        } else {
           $this->Cell(30,5,'Pagina '.$this->getGroupPageNo().' di '.$this->getPageGroupAlias(),0,0,'L');
        }
        $this->Ln(6);
        $interlinea = $this->GetY();
        $this->Ln(6);
        $this->SetFont('freesans','',9);
        if (!empty ($this->destinazione)) {
            if (is_array($this->destinazione)){ //quando si vuole indicare un titolo diverso da destinazione si deve passare un array con titolo index 0 e descrizione index 1
                $this->Cell(80,5,$this->destinazione[0],'LTR',2,'L',1);
                $this->MultiCell(80,4,$this->destinazione[1],'LBR','L');
            } else {
                $this->Cell(80,5,"Destinazione :",'LTR',2,'L',1);
                $this->MultiCell(80,4,$this->destinazione,'LBR','L');
            }
        }
        $this->SetFont('freesans','',10);
        $this->SetXY(110,$interlinea+3);
        $this->Cell(15,5,'Spett.le ',0,0,'R');
        $this->Cell(75,5,$this->cliente1,0,1,'L');
        if (!empty ($this->cliente2)) {
            $this->Cell(115);
            $this->Cell(75,5,$this->cliente2,0,1,'L');
        }
        $this->SetFont('freesans','',10);
        $this->Cell(115);
        $this->Cell(75,5,$this->cliente3,0,1,'L');
        $this->Cell(115);
        $this->Cell(75,5,$this->cliente4,0,1,'L');
        $this->SetFont('freesans','',7);
        $this->Cell(115);
        $this->Cell(75,5,$this->cliente5,0,1,'L');
        if (!empty ($this->c_Attenzione)) {
            $this->SetFont('freesans','',10);
            $this->Cell(115,8,'alla C.A.',0,0,'R');
            $this->Cell(75,8,$this->c_Attenzione,0,1);
        }
        $this->SetFont('freesans','',7);
        if (!empty ($this->clientSedeLegale)) {
            $this->Cell(115,8,'Sede legale: ',0,0,'R');
            $this->Cell(75,8,$this->clientSedeLegale,0,1);
        } else {
            $this->Ln(4);
        }
        if (isset($this->topline)) {
            $this->Ln(10);
            $this->Cell(10,4,'');
            $this->Cell(164,4,'','T',1,'C',1);
            $this->Ln(6);
        }
    }

}