<?php
 /* $Id: document.php,v 1.7 2008/10/30 14:07:14 devincen Exp $
 --------------------------------------------------------------------------
                            Gazie - Gestione Azienda
    Copyright (C) 2004-2008 - Antonio De Vincentiis Montesilvano (PE)
                                (www.devincentiis.it)
                        <http://gazie.sourceforge.net>
 --------------------------------------------------------------------------
    Questo programma e` free software;   e` lecito redistribuirlo  e/o
    modificarlo secondo i  termini della Licenza Pubblica Generica GNU
    come e` pubblicata dalla Free Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.

    Questo programma  e` distribuito nella speranza  che sia utile, ma
    SENZA   ALCUNA GARANZIA; senza  neppure  la  garanzia implicita di
    NEGOZIABILITA` o di  APPLICABILITA` PER UN  PARTICOLARE SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.

    Ognuno dovrebbe avere   ricevuto una copia  della Licenza Pubblica
    Generica GNU insieme a   questo programma; in caso  contrario,  si
    scriva   alla   Free  Software Foundation,  Inc.,   59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA Stati Uniti.
 --------------------------------------------------------------------------
*/

class DocContabVars
{
    function setVars($gTables, $tesdoc, $testat, $tableName)
    {
        $this->gTables = $gTables;
        $this->pagame = getRow($gTables['pagame'], "codice", $tesdoc['pagame']);
        $this->banapp = getRow($gTables['banapp'],"codice",$tesdoc['banapp']);
        $this->banacc = getRow($gTables['clfoco'], 'codice', $this->pagame['id_bank']);
        $this->vettor = getRow($gTables['vettor'], "codice", $tesdoc['vettor']);
        $this->tableName = $tableName;
        $mesefatt = ucwords(strftime("%B", mktime (0,0,0,substr($tesdoc['datfat'],5,2),1,0)));
        $nomemese = ucwords(strftime("%B", mktime (0,0,0,substr($tesdoc['datemi'],5,2),1,0)));
        if ( $tesdoc['numfat'] != 0 and $tesdoc['datfat'] > 0 ) {  //se ho il numero e la data del documento
           $this->emissione = $tesdoc['numfat'].'/'.$tesdoc['seziva'].' del '.substr($tesdoc['datfat'],8,2).' '.$mesefatt.' '.substr($tesdoc['datfat'],0,4);
        } elseif ( $tesdoc['numfat'] == 0 and $tesdoc['datfat'] > 0 ) { //se non c'e' il numero del documento ma c'e' la data
           $this->emissione = $tesdoc['spediz'].'____ del '.substr($tesdoc['datfat'],8,2).' '.$mesefatt.' '.substr($tesdoc['datfat'],0,4);
        } else {//uso il campo spedizione impropriamente per la carta intestata
           $this->emissione = $tesdoc['spediz'];
        }
        if ( $tesdoc['numdoc'] != 0 and $tesdoc['datemi'] > 0 ) {  //se ho il numero e la data del documento
           $this->emissioneddt = $tesdoc['numdoc'].'/'.$tesdoc['seziva'].' del '.substr($tesdoc['datemi'],8,2).' '.$nomemese.' '.substr($tesdoc['datemi'],0,4);
        } elseif ( $tesdoc['numdoc'] == 0 and $tesdoc['datemi'] > 0 ) { //se non c'e' il numero del documento ma c'e' la data
           $this->emissioneddt = $tesdoc['spediz'].'____ del '.substr($tesdoc['datemi'],8,2).' '.$mesefatt.' '.substr($tesdoc['datfat'],0,4);
        } else {//uso il campo spedizione impropriamente per la carta intestata
           $this->emissioneddt = $tesdoc['spediz'];
        }
        $azienda = getRow($gTables['aziend'], 'codice', 1);
        $this->intesta1 = $azienda['ragso1'];
        $this->intesta1bis = $azienda['ragso2'];
        $this->intesta2 = $azienda['indspe'].' '.sprintf("%05d",$azienda['capspe']).' '.$azienda['citspe'].' ('.$azienda['prospe'].')';
        $this->intesta3 = 'Tel.'.$azienda['telefo'].' ';
        $this->aziendTel = $azienda['telefo'];
        $this->aziendFax = $azienda['fax'];
        $this->codici = '';
        if ($azienda['codfis'] != '') {
            $this->codici .= 'C.F. '.$azienda['codfis'].' ';
        }
        if ($azienda['pariva']) {
            $this->codici .= 'P.I. '.$azienda['pariva'].' ';
        }
        if ($azienda['rea']) {
            $this->codici .= 'R.E.A. '.$azienda['rea'];
        }
        $this->intesta4 = $azienda['e_mail'];
        $this->intesta5 = $azienda['sexper'];
        $this->colore = $azienda['colore'];
        $this->decimal_quantity = $azienda['decimal_quantity'];
        $this->decimal_price = $azienda['decimal_price'];
        $this->logo = $azienda['image'];
        $this->perbollo = $azienda['perbol'];
        $anagrafica = new Anagrafica();
        $this->client = $anagrafica->getPartner($tesdoc['clfoco']);
        $this->cliente1 = $this->client['ragso1'];
        $this->cliente2 = $this->client['ragso2'];
        $this->cliente3 = $this->client['indspe'];
        if (!empty($this->client['citspe'])) {
           $this->cliente4 = sprintf("%05d",$this->client['capspe']).' '.$this->client['citspe'].' ('.$this->client['prospe'].')';
        } else {
           $this->cliente4 = '';
        }
        if (!empty($this->client['pariva'])){
           $this->cliente5 = 'P.I. '.$this->client['pariva'].' ';
        } else {
           $this->cliente5 = '';
        }
        if (!empty($this->client['pariva'])){ //se c'e' la partita iva
            if (!empty($this->client['codfis']) and $this->client['codfis'] == $this->client['pariva']) {
                $this->cliente5 = 'C.F. e P.I. '.$this->client['codfis'];
            } elseif(!empty($this->client['codfis']) and $this->client['codfis'] != $this->client['pariva']) {
                $this->cliente5 = 'C.F. '.$this->client['codfis'].' P.I. '.$this->client['pariva'];
            } else { //per es. se non c'e' il codice fiscale
                $this->cliente5 = ' P.I. '.$this->client['pariva'];
            }
        } else { //se  NON c'e' la partita iva
            $this->cliente5 = '';
            if (!empty($this->client['codfis'])) {
                $this->cliente5 = 'C.F. '.$this->client['codfis'];
            }
        }
        // variabile e' sempre un array
        $this->id_agente = getRow($gTables['agenti'],'id_agente',$tesdoc['id_agente']);
        $this->rs_agente = $anagrafica->getPartner($this->id_agente['id_fornitore']);
        $this->name_agente = substr($this->rs_agente['ragso1']." ".$this->rs_agente['ragso2'],0,47);
        if ((isset($tesdoc['id_des'])) and ($tesdoc['id_des'] > 0)) {
            $this->partner_dest = $anagrafica->getPartner($tesdoc['id_des']);
            $this->destinazione = substr($this->partner_dest['ragso1']." ".$this->partner_dest['ragso2'],0,45);
            $this->destinazione .= "\n".substr($this->partner_dest['indspe'],0,45);
            $this->destinazione .= "\n".substr($this->partner_dest['capspe']." ".$this->partner_dest['citspe']." (".$this->partner_dest['prospe'].")",0,45);
        } else {
            if (isset($tesdoc['destin']) and is_array($tesdoc['destin'])) {
                $this->destinazione = $tesdoc['destin'];
            } elseif (isset($tesdoc['destin']) and is_string($tesdoc['destin'])) {
                $destino = split("[\r\n]+",$tesdoc['destin'],3);
                $this->destinazione = substr($destino[0],0,45);
                foreach ($destino as $key => $value) {
                    if ($key == 1){
                        $this->destinazione .= "\n".substr($value,0,45)."\n";
                    } elseif($key > 1) {
                        $this->destinazione .= substr(ereg_replace("[\r\n]+",' ',$value),0,45);
                    }
                }
            } else {
                $this->destinazione = '';
            }
        }

        $this->clientSedeLegale = ((trim($this->client['sedleg']) != '') ? split("\n", trim($this->client['sedleg'])) : array());

        if (isset($tesdoc['c_a'])) {
           $this->c_Attenzione = $tesdoc['c_a'];
        } else {
           $this->c_Attenzione = '';
        }
        $this->client = $anagrafica->getPartner($tesdoc['clfoco']);
        $this->tesdoc = $tesdoc;
        $this->min = substr($tesdoc['initra'],14,2);
        $this->ora = substr($tesdoc['initra'],11,2);
        $this->day = substr($tesdoc['initra'],8,2);
        $this->month = substr($tesdoc['initra'],5,2);
        $this->year = substr($tesdoc['initra'],0,4);
        $this->trasporto=$tesdoc['traspo'];
        $this->testat = $testat;
    }

    function getRigo()
    {
        //azzero il totale peso
        $this->quatot = 0;
        $rs_rig = dynQuery("*", $this->gTables[$this->tableName], "id_tes = $this->testat", "id_rig asc");
        $results = array();
        while ($rigo = dbms_fetch_array($rs_rig)) {
            //calcolo importo rigo
            $rigo['importo'] = CalcolaImportoRigo($rigo['quanti'], $rigo['prelis'], $rigo['sconto']);
            if ($rigo['tiprig'] == 1) {
               $rigo['importo'] = CalcolaImportoRigo(1, $rigo['prelis'], 0);
            }
            if ($rigo['tiprig'] == 3) {
               if (!isset($this->totriport)) {
                  $this->totriport = 0.00;
               }
               $this->totriport = $rigo['prelis'] + $this->totriport;
            }
            $results[] = $rigo;
            //calcolo il totale del peso in kg
            switch(strtolower($rigo['unimis'])) {
            case "kg":
                $this->quatot = ($rigo['quanti']) + $this->quatot;
                break;
            }
            //creo il castelletto IVA ma solo se del tipo normale o forfait
            if ($rigo['tiprig'] <= 1) {
                if (! isset($this->castel[$rigo['codvat']])) {
                    $this->castel[$rigo['codvat']] = 0;
                }
                $this->castel[$rigo['codvat']] = $this->castel[$rigo['codvat']] + $rigo['importo'];
            }
        }
        return $results;
    }

    function setTotal($totTrasporto=0)
    {
        $bolli = new Compute();
        $this->totimpmer = 0.00;
        $this->totivafat = 0.00;
        $this->totimpfat = 0.00;
        $this->impbol = 0.00;
        if (!isset($this->totriport)){
           $this->totriport = 0.00;
        }
        $this->speseincasso = $this->tesdoc['speban'] * $this->pagame['numrat'];
        if (!isset($this->castel)){
            $this->castel= array();
        }
        $this->cast = array();
        $chk_add_iva_tes = 0;
        foreach ($this->castel as $key => $value) {
            $impcast = $value - $value * $this->tesdoc['sconto']/100;
            if ($key == $this->tesdoc['ivaspe']) {
                $impcast = $impcast + $totTrasporto + $this->speseincasso;
                $chk_add_iva_tes = 1;
            }
            $iva_cast = getRow($this->gTables['aliiva'],"codice",$key);
            $ivacast =  round($impcast * $iva_cast['aliquo']) / 100;
            $this->totimpmer += $value;
            $this->totimpfat += $impcast;
            $this->totivafat += $ivacast;
            $this->cast[$key]['impcast'] = $impcast;
            $this->cast[$key]['ivacast'] = $ivacast;
            $this->cast[$key]['descriz'] = $iva_cast['descri'];
        }
        if ($chk_add_iva_tes == 0){// se le spese della testata non sono state aggiunte perch non si  incontrato uno stesso codice IVA
            $codivaspe = $this->tesdoc['ivaspe'];
            $iva_cast = getRow($this->gTables['aliiva'],"codice",$codivaspe);
            $iva_testata =  round(($totTrasporto + $this->speseincasso) * $iva_cast['aliquo']) / 100;
            $this->cast[$codivaspe]['impcast'] = $totTrasporto + $this->speseincasso;
            $this->cast[$codivaspe]['ivacast'] = $iva_testata;
            $this->cast[$codivaspe]['descriz'] = $iva_cast['descri'];
            $this->totimpfat += $totTrasporto + $this->speseincasso;
            $this->totivafat += $iva_testata;
            $chk_add_iva_tes = 1;
        }
        //se il pagamento e' del tipo TRATTA calcolo i bolli da addebitare per l'emissione dell'effetto
        if ($this->pagame['tippag'] == 'T') {
            $this->impbol = $bolli->stampTax($this->totimpfat+$this->totriport+$this->totivafat,$this->perbollo);
        }
    }
}


function createDocument($docVars, $templateName)
{
    $templates = array(
                       'CartaIntestata' => 'carta_intestata',
                       'Lettera' => 'lettera',
                       'FatturaAcquisto' => 'fattura_acquisto',
                       'FatturaImmediata' => 'fattura_immediata',
                       'PreventivoCliente' => 'preventivo_cliente',
                       'OrdineCliente' => 'ordine_cliente',
                       'FatturaSemplice' => 'fattura_semplice',
                       'OrdineFornitore' => 'ordine_fornitore',
                       'PreventivoFornitore' => 'preventivo_fornitore',
                       'InformativaPrivacy' => 'informativa_privacy',
                       'DDT' => 'ddt'
                       );

    $config = new Config;
    require_once("../../config/templates".($config->getValue('template') ? '.'.$config->getValue('template') : '').'/'.$templates[$templateName].'.php');
    $pdf = new $templateName();
    $pdf->SetPageFormat($config->getValue('page_format'));
    $pdf->setCreator(PDF_CREATOR);
    $pdf->setAuthor($docVars->intesta1.' '.$_SESSION['Login']);
    $pdf->setTitle($templateName);
    $pdf->setTopMargin(79);
    $pdf->setHeaderMargin(5);
    $pdf->setVars($docVars,$templateName);
    $pdf->Open();
    $pdf->AliasNbPages();
    $pdf->pageHeader();
    $pdf->compose();
    $pdf->pageFooter();
    $pdf->Output();
}

function createMultiDocument($results, $templateName, $gTables)
{
    $templates = array(
                       'CartaIntestata' => 'carta_intestata',
                       'Lettera' => 'lettera',
                       'FatturaAcquisto' => 'fattura_acquisto',
                       'FatturaImmediata' => 'fattura_immediata',
                       'PreventivoCliente' => 'preventivo_cliente',
                       'OrdineCliente' => 'ordine_cliente',
                       'FatturaSemplice' => 'fattura_semplice',
                       'OrdineFornitore' => 'ordine_fornitore',
                       'PreventivoFornitore' => 'preventivo_fornitore',
                       'InformativaPrivacy' => 'informativa_privacy',
                       'DDT' => 'ddt'
                       );

    $config = new Config;
    require_once("../../config/templates".($config->getValue('template') ? '.'.$config->getValue('template') : '').'/'.$templates[$templateName].'.php');
    $pdf = new $templateName();
    $pdf->SetPageFormat($config->getValue('page_format'));
    $pdf->SetCreator(PDF_CREATOR);
    $pdf->SetAuthor($docVars->intesta1.' '.$_SESSION['Login']);
    $pdf->SetTitle($templateName);
    $pdf->SetTopMargin(79);
    $pdf->SetHeaderMargin(5);
    $pdf->Open();
    $ctrlprotoc = 0;
    while ($tesdoc = dbms_fetch_array($results)) {
    //se il cliente non e' lo stesso di prima
        if ($tesdoc['protoc'] <> $ctrlprotoc) {
            //se non e' piu' lo stesso cliente e non e' il primo Ddt stampo il piede della fattura
            if ($ctrlprotoc <> "") {
                $pdf->pageFooter();
            }
            // Inizio pagina
            $testat = $tesdoc['id_tes'];
            $docVars = new DocContabVars();
            $docVars->setVars($gTables, $tesdoc, $testat, 'rigdoc');
            $pdf->setVars($docVars,$templateName);
            //aggiungo una pagina
            $pdf->pageHeader();
            $ctrlprotoc = $tesdoc['protoc'];
        }
        $testat = $tesdoc['id_tes'];
        $pdf->docVars->setVars($gTables, $tesdoc, $testat, 'rigdoc');
        $pdf->compose();
    }
    $pdf->pageFooter();
    $pdf->Output();
}

function createInvoiceFromDDT($result,$gTables) {
    $config = new Config;
    require_once("../../config/templates".($config->getValue('template') ? '.'.$config->getValue('template') : '').'/fattura_semplice.php');
    $pdf = new FatturaSemplice();
    $pdf->SetPageFormat($config->getValue('page_format'));
    $pdf->SetCreator(PDF_CREATOR);
    $pdf->SetAuthor($docVars->intesta1.' '.$_SESSION['Login']);
    $pdf->SetTitle($templateName);
    $pdf->SetTopMargin(79);
    $pdf->SetHeaderMargin(5);
    $pdf->Open();
    $ctrlprotoc = 0;
    while ($tesdoc = dbms_fetch_array($result)) {
    //se il cliente non e' lo stesso di prima
        if ($tesdoc['protoc'] <> $ctrlprotoc) {
            //se non e' piu' lo stesso cliente e non e' il primo Ddt stampo il piede della fattura
            if ($ctrlprotoc <> "") {
                $pdf->pageFooter();
            }
            // Inizio pagina
            // se non e' il tipo di documento stampabile da questo modulo ... va a casa
               if ($tesdoc['tipdoc'] <> 'FAD') {
                header("Location: report_docven.php");
                exit;
               }

            $testat = $tesdoc['id_tes'];
            $docVars = new DocContabVars();
            $docVars->setVars($gTables, $tesdoc, $testat, 'rigdoc');
            $pdf->setVars($docVars);
            //aggiungo una pagina
            $pdf->pageHeader();
            $ctrlprotoc = $tesdoc['protoc'];
        }
        $testat = $tesdoc['id_tes'];
        $pdf->docVars->setVars($gTables, $tesdoc, $testat, 'rigdoc');
        $pdf->compose();
    }
    $pdf->pageFooter();
    $pdf->Output();
}

?>