<?php
/* $Id: function.inc.php,v 1.6 2008/10/29 16:37:17 devincen Exp $
 --------------------------------------------------------------------------
                            Gazie - Gestione Azienda
    Copyright (C) 2004-2008 - Antonio De Vincentiis Montesilvano (PE)
                                (www.devincentiis.it)
                        <http://gazie.sourceforge.net>
 --------------------------------------------------------------------------
    Questo programma e` free software;   e` lecito redistribuirlo  e/o
    modificarlo secondo i  termini della Licenza Pubblica Generica GNU
    come e` pubblicata dalla Free Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.

    Questo programma  e` distribuito nella speranza  che sia utile, ma
    SENZA   ALCUNA GARANZIA; senza  neppure  la  garanzia implicita di
    NEGOZIABILITA` o di  APPLICABILITA` PER UN  PARTICOLARE SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.

    Ognuno dovrebbe avere   ricevuto una copia  della Licenza Pubblica
    Generica GNU insieme a   questo programma; in caso  contrario,  si
    scriva   alla   Free  Software Foundation,  Inc.,   59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA Stati Uniti.
 --------------------------------------------------------------------------
*/

connectToDB();
session_cache_limiter('nocache');
session_start();
$direttorio = explode("/",dirname($_SERVER['PHP_SELF']));
$module = array_pop($direttorio);
$diffearr = array('modules',$module,'');
$radixarr = array_diff($direttorio,$diffearr);
$nameradi= implode('/',$radixarr);

if ( strtoupper(substr(PHP_OS, 0, 3)) === 'WIN' || strtoupper(substr(PHP_OS, 0, 3)) === 'VIS' ) {
    setlocale (LC_TIME, 'it');
} else {
    setlocale (LC_TIME, 'it_IT.UTF-8');
}

// funzione che controlla se l'azienda e' stata configurata
function checkaziend()
{
    global $gTables;
    $config = getRow($gTables['aziend'],'codice',1);
    return $config;
}

function gaz_format_number($number)
{
    return number_format($number, 2, ',', '.');
}

function gaz_format_quantity($number,$comma=false,$decimal=false)
{
    $number =  sprintf("%.3f",ereg_replace(',','.',$number)); //max 3 decimal
    if (!$decimal) { // decimal is not defined (depreceted in recursive call)
        global $gTables;
        $config = getRow($gTables['aziend'],'codice',1);
        $decimal = $config['decimal_quantity'];
    }
    if ($decimal > 3){ //float
       if ($comma == true){
          return ereg_replace('\.',',',floatval($number));
       } else {
          return floatval($number);
       }
    } else { //decimal defined
       if ($comma == true){
          return number_format($number, $decimal,',','.');
       } else {
          return number_format($number, $decimal,'.','');
       }
    }
}

function CalcolaImportoRigo($quantita, $prezzo, $sconto, $decimal=2)
{
   if (is_array($sconto)){
     $res = 1;
     foreach ($sconto as $val) {
          $res -= $res*$val/100;
     }
     $res = 1 - $res;
   } else {
     $res=$sconto/100;
   }
   return round($quantita * ($prezzo - $prezzo * $res),$decimal);
}

function getUserLang($money)
{
   global $gTables;
   $user = getRow($gTables['admin'],'Login',$_SESSION['Login']);
   if (!empty ($user['lang'])){
       $lang = $user['lang'];
   } else {
       $lang = 'italian';
   }
   return $lang;
}

class Config
{
    function Config()
    {
        global $gTables;
        $results = dbms_query ("SELECT variable, cvalue FROM " . $gTables['config']);

        while($row = dbms_fetch_object($results)) {
            $this->{$row->variable} = $row->cvalue;
        }
    }

    function getValue($variable)
    {
        return $this->{$variable};
    }

    function setValue($variable, $value)
    {
        $this->{$variable} = $value;
        //
        // TODO: Inserimento in tabella
        //
    }

} // end Config

class Anagrafica
{
    function Anagrafica ()
    {
        global $gTables;
        $this->gTables = $gTables;
        $this->tableClfoco = $gTables['clfoco'];
    }
    function getPartner ($idClfoco)
    {
        return getRow($this->tableClfoco, "codice", $idClfoco);
    }

    function deletePartner ($idClfoco)
    {
        delRow($this->tableClfoco, "codice", $idClfoco);
    }

    function queryPartners ($select, $where=1, $orderby=2, $limit=0, $passo=100000)
    {
        $result = dynQuery ($select, $this->tableClfoco, $where, $orderby, $limit, $passo);
        $partners = array();
        while ($row = dbms_fetch_array($result)) {
            $partners[] = $row;
        }
        return $partners;
    }

    function getMovimenti ($contoinizio, $contofine, $datainizio, $datafine)
    {
        if ($contoinizio == $contofine) {
            $where = " codcon = {$contoinizio} AND datreg BETWEEN {$datainizio} AND {$datafine} ";
            $orderby = " datreg ASC ";
            $select = $this->gTables['tesmov'].".id_tes,datreg,codice,ragso1,numdoc,datdoc,descri,import*(darave='D') AS dare,import*(darave='A') AS avere";
        } else {
            $where = $this->tableClfoco.".codice BETWEEN {$contoinizio} AND {$contofine} AND datreg BETWEEN {$datainizio} AND {$datafine} GROUP BY ".$this->tableClfoco.".codice";
            $orderby = " codice ASC ";
            $select = "codice, ragso1, COUNT(id_rig) AS righi, SUM(import*(darave='D')) AS dare, SUM(import*(darave='A')) AS avere";
        }
        $tabella = $this->tableClfoco." LEFT JOIN ".$this->gTables['rigmoc']." ON ".$this->tableClfoco.".codice = ".$this->gTables['rigmoc'].".codcon "
                    ."LEFT JOIN ".$this->gTables['tesmov']." ON ".$this->gTables['rigmoc'].".id_tes = ".$this->gTables['tesmov'].".id_tes ";

        $movimenti = array();
        $result = dynQuery ($select, $tabella, $where, $orderby);
        while ($row = dbms_fetch_array($result)) {
            $movimenti[] = $row;
        }
        return $movimenti;
    }

    function getMovimentiPartitario ()
    {

        $movimenti = array();
        $result = dynQuery ($select, $tabella, $where, $orderby);
        while ($row = dbms_fetch_array($result)) {
            $movimenti[] = $row;
        }
        return $movimenti;
    }
}

//===============================================================================
// classe generica per la generazione di select box
//================================================================================
class SelectBox
{
    var $name;
    // assegno subito il nome della select box
    function SelectBox($name)
    {
        $this -> name = $name;
    }

    function setSelected($selected)
    {
        $this->selected = $selected;
        }

    function addSelected($selected)
    {
        $this->setSelected($selected);
        }

    function output($query, $index1, $empty=False, $bridge='', $index2='', $key='codice', $refresh='')
    {
        if (!empty($refresh)){
            $refresh = "onchange=\"this.form.hidden_req.value='$refresh'; this.form.submit();\"";
        }
        print "\t <select name=\"$this->name\" class=\"FacetSelect\" $refresh >\n";
        if ($empty) {
            print "\t\t <option value=\"\"></option>\n";
        }
        $result = dbms_query($query);
        while ($a_row = dbms_fetch_array($result)) {
            $selected = "";
            if($a_row[$key] == $this->selected) {
                $selected = "selected";
            }
            print "\t\t <option value=\"".$a_row[$key]."\" $selected >";
            if (empty($index2)) {
                print substr($a_row[$index1],0,43)."</option>\n";
            } else {
                print substr($a_row[$index1],0,28).$bridge.substr($a_row[$index2],0,35)."</option>\n";
            }
        }
        print "\t </select>\n";
    }
}

// classe per la generazione di select box dei clienti,fornitori,conti
class selectclfoco extends SelectBox
{
    function output($mastro,$cerca)
    {
        global $gTables,$strMessage,$strButton;
        $messaggio = "";
        $tabula = " tabindex=\"1\" ";
        if (strlen($cerca) >= 2) {
            $mascon=$mastro.'000000';
            $result = dynQuery("*", $gTables['clfoco'],"codice LIKE '$mastro%' AND codice > '$mascon' AND ragso1 LIKE '$cerca%'","ragso1 Desc");
            $numclfoco = dbms_num_rows($result);
            if ($numclfoco > 0) {
                $tabula =" ";
                print "\t <select name=\"$this->name\" class=\"FacetSelect\">\n";
                while ($a_row = dbms_fetch_array($result)) {
                    $selected = "";
                    if($a_row["codice"] == $this->selected) {
                        $selected = "selected";
                    }
                    print "\t\t <option value=\"".$a_row["codice"]."\" $selected >".$a_row["ragso1"]."&nbsp;".$a_row["citspe"]."</option>\n";
                }
                print "\t </select>\n";
            } else {
                $messaggio = $strMessage['notfound']."!\n";
                print "\t<input type=\"hidden\" name=\"$this->name\" value=\"\">\n";
            }
        } else {
                $messaggio = $strMessage['minins']." 2 ".$strMessage['charat']."!\n";
                print "\t<input type=\"hidden\" name=\"$this->name\" value=\"\">\n";
        }
        print "\t<td><input type=\"text\" name=\"ragso1\" ".$tabula." accesskey=\"e\" value=\"".stripslashes($cerca)."\" maxlength=\"15\" size=\"9\" class=\"FacetInput\">\n";
        print $messaggio;
        print "\t <input type=\"image\" align=\"middle\" accesskey=\"c\" ".$tabula." name=\"clfoco\" src=\"../../library/images/cerbut.gif\" title=\"{$strButton['search']}\"></td>\n";
    }
}
// classe per la generazione di select box dei clienti e fornitori (partner commerciali)
class selectPartner extends SelectBox
{
    function output($mastro,$cerca)
    {
        global $strMessage,$strButton;
        $messaggio = "";
        $tabula = " tabindex=\"1\" ";
        if (strlen($cerca) >= 2) {
            $mascon = $mastro.'000000';
            $anagrafica = new Anagrafica();
            if (is_numeric($cerca)){                      //ricerca per partita iva
              $partners = $anagrafica->queryPartners("*", "codice LIKE '$mastro%' AND codice > '$mascon' AND pariva = $cerca ","ragso1 DESC");
            } elseif (is_numeric(substr($cerca,6,2))) {   //ricerca per codice fiscale
              $partners = $anagrafica->queryPartners("*", "codice LIKE '$mastro%' AND codice > '$mascon' AND codfis LIKE '%$cerca%' AND status <> 'HIDDEN'","ragso1 DESC");
            } else {                                      //ricerca per ragione sociale
              $partners = $anagrafica->queryPartners("*", "codice LIKE '$mastro%' AND codice > '$mascon' AND ragso1 LIKE '$cerca%' AND status <> 'HIDDEN'","ragso1 DESC");
            }
            $numclfoco = sizeof($partners);
            if ($numclfoco > 0) {
                $tabula =" ";
                print "\t <select name=\"$this->name\" class=\"FacetSelect\">\n";
                while (list($key, $a_row) = each($partners)) {
                    $selected = "";
                    if($a_row["codice"] == $this->selected) {
                        $selected = "selected";
                    }
                    print "\t\t <option value=\"".$a_row["codice"]."\" $selected >".$a_row["ragso1"]."&nbsp;".$a_row["citspe"]."</option>\n";
                }
                print "\t </select>\n";
            } else {
                $messaggio = $strMessage['notfound']."!\n";
                print "\t<input type=\"hidden\" name=\"$this->name\" value=\"\">\n";
            }
        } else {
                $messaggio = $strMessage['minins']." 2 ".$strMessage['charat']."!\n";
                print "\t<input type=\"hidden\" name=\"$this->name\" value=\"\">\n";
        }
        print "\t<input type=\"text\" name=\"ragso1\" ".$tabula." accesskey=\"e\" value=\"".stripslashes($cerca)."\" maxlength=\"15\" size=\"9\" class=\"FacetInput\">\n";
        print $messaggio;
        print "\t<input type=\"image\" align=\"middle\" accesskey=\"c\" ".$tabula." name=\"clfoco\" src=\"../../library/images/cerbut.gif\" title=\"{$strButton['search']}\">\n";
    }
}

// classe per la generazione di select box degli articoli
class selectartico extends SelectBox
{
    function output($cerca,$field='C')
    {
        global $gTables,$strMessage,$strButton;
        $messaggio = "";
        $tabula = " tabindex=\"4\" ";
        if (strlen($cerca) >= 1) {
            if ($field == 'B'){        //ricerca per codice a barre
                $field_sql = 'barcode';
            } elseif ($field == 'D') { //ricerca per descrizione
                $field_sql = 'descri';
            } else {                   //ricerca per codice (default)
                $field_sql = 'codice';
            }
            $result = dynQuery("codice,descri,barcode", $gTables['artico'],$field_sql." LIKE '$cerca%'","descri DESC");
            $numclfoco = dbms_num_rows($result);
            if ($numclfoco > 0) {
                $tabula = "";
                print "\t <select tabindex=\"4\" name=\"$this->name\" class=\"FacetSelect\">\n";
                while ($a_row = dbms_fetch_array($result)) {
                    $selected = "";
                    if($a_row["codice"] == $this->selected) {
                        $selected = "selected";
                    }
                    print "\t\t <option value=\"".$a_row["codice"]."\" $selected >".$a_row["codice"]."-".$a_row["descri"]."</option>\n";
                }
                print "\t </select>\n";
            } else {
                $messaggio = $strMessage['notfound']."!\n";
                print "\t<input type=\"hidden\" name=\"$this->name\" value=\"\">\n";
            }
        } else {
                $messaggio = $strMessage['minins']." 1 ".$strMessage['charat']."!\n";
            print "\t<input type=\"hidden\" name=\"$this->name\" value=\"\">\n";
        }
        print "\t<input type=\"text\" name=\"cosear\" value=\"".stripslashes($cerca)."\" ".$tabula." maxlength=\"16\" size=\"9\" class=\"FacetInput\">\n";
        print $messaggio;
        print "\t<input type=\"image\" align=\"middle\" accesskey=\"c\" name=\"artico\" ".$tabula." src=\"../../library/images/cerbut.gif\" title=\"{$strButton['search']}\">\n";
    }
}

// classe per la generazione di select box dei conti ricavi di vendita-costi d'acquisto
class selectconven extends SelectBox
{
    function output($mastri)
    {
        global $gTables;
        $query = 'SELECT * FROM `'.$gTables['clfoco']."` WHERE codice LIKE '".$mastri."%' AND codice NOT LIKE '%000000' ORDER BY `codice` ASC";
        SelectBox::output($query, 'codice', False, '-', 'ragso1');
    }
}

// classe per la generazione di select box dei conti ricavi di vendita-costi d'acquisto
class selectbanacc extends SelectBox
{
    function output($mastri)
    {
        global $gTables;
        $query = 'SELECT * FROM `'.$gTables['clfoco']."` WHERE codice LIKE '".$mastri."%' AND codice > '".$mastri."000000' ORDER BY `codice` ASC";
        SelectBox::output($query, 'codice', True, '-', 'ragso1');
    }
}

// classe per la generazione di select box banche d'appoggio
class selectbanapp extends SelectBox
{
    function output()
    {
        global $gTables;
        $query = 'SELECT * FROM `'.$gTables['banapp'].'` ORDER BY `descri`';
        SelectBox::output($query, 'descri', True, ' ', 'locali');
    }
}

// classe per la generazione di select box dei pagamenti
class selectpagame extends SelectBox
{
    function output()
    {
        global $gTables;
        $query = 'SELECT * FROM `'.$gTables['pagame'].'` ORDER BY `codice`';
        SelectBox::output($query, 'descri', True);
    }
}

// classe per la generazione di select box delle aliquote iva
class selectaliiva extends SelectBox
{
    function output()
    {

        global $gTables;

        $query = 'SELECT * FROM `'.$gTables['aliiva'].'` ORDER BY `codice`';

        SelectBox::output($query, 'descri', True);
    }
}

// classe per la generazione di select box delle categorie merceologiche
class selectcatmer extends SelectBox
{
    function output($refresh='')
    {
        global $gTables;
        $query = 'SELECT * FROM `'.$gTables['catmer'].'` ORDER BY `codice`';
        SelectBox::output($query, 'codice', True, '-', 'descri','codice',$refresh);
    }
}

// classe per la generazione di select box porto resa
class selectportos extends SelectBox
{
    function output()
    {
        global $gTables;
        $query = 'SELECT * FROM `'.$gTables['portos'].'` ORDER BY `codice`';
        SelectBox::output($query, 'codice', True, '-', 'descri');
    }
}

// classe per la generazione di select box delle spedizioni
class selectspediz extends SelectBox
{
    function output()
    {
        global $gTables;
        $query = 'SELECT * FROM `'.$gTables['spediz'].'` ORDER BY `codice`';
        SelectBox::output($query, 'codice', True, '-', 'descri');
    }
}

// classe per la generazione di select box imballi
class selectimball extends SelectBox
{
    function output()
    {
        global $gTables;
        $query = 'SELECT * FROM `'.$gTables['imball'].'` ORDER BY `codice`';
        SelectBox::output($query, 'codice', True, '-', 'descri');
    }
}

// classe per la generazione di select box imballi, spedizioni, porto resa
class SelectValue extends SelectBox
{
    function output($table, $fieldName)
    {
        // 'spediz' 'portos' 'imball'
        // $fieldName - il nome del campo da impostare
        global $gTables;
        $query = 'SELECT * FROM `'.$gTables[$table].'` ORDER BY `codice`';
        $index1 = 'codice';
        $empty = True;
        $bridge = '&nbsp; ';
        $index2 = 'descri';
        print "\t <select name=\"$this->name\" class=\"FacetSelect\" onChange=\"pulldown_menu('".$this->name."','".$fieldName."')\" style=\"width: 20px\">\n";
        //print "\t <select name=\"$this->name\" class=\"FacetSelect\" onChange=\"pulldown_menu('".$this->name."','".$fieldName."')\" style=\"width: 80px\">\n";
        if ($empty) {
            print "\t\t <option value=\"\"></option>\n";
        }
        $result = dbms_query($query);
        while ($a_row = dbms_fetch_array($result)) {
            if ($index2 == '') {
                print "\t\t <option value=\"\">".$a_row[$index1]."</option>\n";
            } else {
                print "\t\t <option value=\"".$a_row[$index2]."\">&nbsp;".$a_row[$index1].$bridge.$a_row[$index2]."</option>\n";
                //print "\t\t <option value=\"".$a_row[$index2]."\">".$a_row[$index2]."</option>\n";
            }
        }
        print "\t </select>\n";
    }
}

// classe per la generazione di select box vettori
class selectvettor extends SelectBox
{
    function output()
    {
        global $gTables;
        print "\t <select name=\"$this->name\" class=\"FacetSelect\">\n";
        print "\t\t <option value=\"\"></option>\n";
        $result = dynQuery("*", $gTables['vettor'],1,"codice");
        while ($a_row = dbms_fetch_array($result)) {
            $selected = "";
            if($a_row["codice"] == $this->selected) {
                $selected = "selected";
            }
            print "\t\t <option value=\"".$a_row["codice"]."\" $selected >".substr($a_row["descri"],0,22)."</option>\n";
        }
        print "\t </select>\n";
    }
}

// classe per la generazione dinamica di select box per le date
class selectDate
{
    // le proprieta' sono i nomi dei select e i tag "selected" sulle option
    var $giorno;
    var $mese;
    var $anno;
    var $dayselected;
    var $monthselected;
    var $yearselected;
    // assegno subito il nome delle select box
    function selectDate($giorno, $mese, $anno)
    {
        $this -> giorno = $giorno;
        $this -> mese = $mese;
        $this -> anno = $anno;
    }

    function daySelected($selected)
    {
        if (!$selected) {
            $selected = strftime("%d");
        }
        $this->dayselected = $selected;
    }

    function monthSelected($selected)
    {
        if (!$selected) {
            $selected = strftime("%m");
        }
        $this->monthselected = $selected;
    }

    function yearSelected($selected)
    {
        if (!$selected) {
            $selected = strftime("%Y");
        }
        $this->yearselected = $selected;
    }

    function output()
    {
        // select del giorno
        print "\t <select name=\"$this->giorno\" class=\"FacetSelect\">\n";
        for( $counter = 1; $counter <= 31; $counter++ ) {
            $selected = "";
            if($counter == $this->dayselected) {
                $selected = "selected";
            }
            print "\t\t <option value=\"$counter\" $selected >$counter</option>\n";
        }
        print "\t </select>\n";
        // select del mese
        print "\t <select name=\"$this->mese\" class=\"FacetSelect\">\n";
        for( $counter = 1; $counter <= 12; $counter++ ) {
            $selected = "";
            if($counter == $this->monthselected) {
                $selected = "selected";
            }
            $nome_mese = ucwords(strftime("%B", mktime (0,0,0,$counter,1,0)));
            print "\t\t <option value=\"$counter\"  $selected >$nome_mese</option>\n";
        }
        print "\t </select>\n";
        // select del anno
        print "\t <select name=\"$this->anno\" class=\"FacetSelect\">\n";
        for( $counter = 1920; $counter <= 2030; $counter++ ) {
            $selected = "";
            if($counter == $this->yearselected) {
                $selected = "selected";
            }
            print "\t\t <option value=\"$counter\"  $selected >$counter</option>\n";
        }
        print "\t </select>\n";
    }
    function outputMA()
    {
        // select del mese
        print "\t <select name=\"$this->mese\" class=\"FacetSelect\">\n";
        for( $counter = 1; $counter <= 12; $counter++ ) {
            $selected = "";
            if($counter == $this->monthselected) {
                $selected = "selected";
            }
            $nome_mese = ucwords(strftime("%B", mktime (0,0,0,$counter,1,0)));
            print "\t\t <option value=\"$counter\"  $selected >$nome_mese</option>\n";
        }
        print "\t </select>\n";
        // select del anno
        print "\t <select name=\"$this->anno\" class=\"FacetSelect\">\n";
        for( $counter = 2002; $counter <= 2030; $counter++ ) {
            $selected = "";
            if($counter == $this->yearselected) {
                $selected = "selected";
            }
            print "\t\t <option value=\"$counter\"  $selected >$counter</option>\n";
        }
        print "\t </select>\n";
    }
    function outputAN()
    {
        // select del anno
        print "\t <select name=\"$this->anno\" class=\"FacetSelect\">\n";
        for( $counter = 2000; $counter <= 2030; $counter++ ) {
            $selected = "";
            if($counter == $this->yearselected) {
                $selected = "selected";
            }
            print "\t\t <option value=\"$counter\"  $selected >$counter</option>\n";
        }
        print "\t </select>\n";
    }
}

/* SEZIONE PER L'ORDINAMENTO DEI RECORD IN OUTPUT */
/* SONO IMPOSTATE TUTE LE VARIABILI NECESSARIE ALLA FUNZIONE dynQuery */
// imposto le variabili di sessione con i valori di default
if (!isset ($_GET['flag_order'])) {
    $flag_order='';
    $flagorpost='';
}
if (!isset ($_GET['auxil'])) {
    $auxil = "1";
}
if (!isset ($limit)) {
    $limit = "0";
}
if (!isset ($passo)) {
    $passo = "20";
}
if (!isset ($field)) {
    $field = "2" ;
}
//flag di ordinamento ascendente e discendente
if (isset ($_GET['flag_order']) && ($_GET['flag_order'] == "DESC")) {
    $flag_order="ASC";
    $flagorpost="DESC";
} elseif (isset ($_GET['flag_order']) && ($_GET['flag_order'] <> "DESC")) {
    $flag_order="DESC";
    $flagorpost="ASC";
}
// se $PHP_SELF e' compreso nel referer (ricaricamento dalla stessa pagina), conservo tutte le variabili di
// sessione, altrimenti resetto $session['field'], $session['limit'], $session['passo'], $session['where'] e session['order']
if (!isset($_SERVER["HTTP_REFERER"])) {
    $_SERVER["HTTP_REFERER"] = "";
}
// If you only want to determine if a particular needle  occurs within haystack, use the faster and less memory intensive function strpos() instead
//if (!strstr ($_SERVER["HTTP_REFERER"],$_SERVER['PHP_SELF'])) {
if (!strpos ($_SERVER["HTTP_REFERER"],$_SERVER['PHP_SELF'])) {
     $field = "2";  // valore che indica alla dynQuery che orderby non va usato
     $flag_order = "DESC"; // per default i dati piu' recenti sono i primi
     $limit = "0";
     $passo = "20";
     $orderby = $field." ".$flag_order;
     $auxil = "1";
     $where = '1';
}
// imposto il nuovo campo per l'ordinamento
if (isset ($_GET['auxil'])) {
    $auxil=$_GET['auxil'];
}
if (isset ($_GET['field'])) {
    $field=$_GET['field'];
}
$orderby = $field.' '.$flag_order;
if (isset ($_GET['limit'])) {
    $limit=$_GET['limit'];
}
// statement where di default = 1
if (!isset ($_GET['where'])) {
    $where = "1";
} else {
    $where = $_GET['where'];
}

// classe che visualizza i pulsanti per la navigazione dei record
// input= tabella, session[where], limit e passo.
// calcola i valori da impostare sulla variabile limit per scorrere i record
// visualizza il numero totale di record e i pulsanti
class   recordnav
{
    var $table;
    var $where;
    var $limit;
    var $passo;
    var $last;
    function recordnav($table, $where, $limit, $passo)
    {
        global $limit, $passo;
        $this->table = $table;
        $this->where = $where;
        $this->limit = $limit;
        $this->passo = $passo;
        // faccio il conto totale dei record selezionati dalla query
        $this->count = queryCount($table, $where);
        // (recordcount - modulo del numero di record diviso il passo)
        $this->last = queryCount($table, $where)-(queryCount($table, $where)%$this->passo);
        //return $last;
    }

    function output ()
    {
        global $flagorpost;
        global $field;
        global $auxil,$strButton;
        $first = 0;
        $next = $this->limit + $this->passo;
        $prev = $this->limit - $this->passo;
        // se e' arrivato a fondo scala imposto il fermo
        if ($prev <= 0) {
            $prev = 0;
        }
        if ($next >= $this->last) {
            $next = $this->last;
        }
        if ( ($this->count) <= $this->passo ) {
            // non visualizzo la barra di navigazione dei record
            print "<div align=\"center\"><font class=\"FacetFormDataFont\">Num. record = $this->count</font></div>";
        } else {
            print "<div align=\"center\"><font class=\"FacetFormDataFont\">Num. record = $this->count</font></div>";
            print "<div align=\"center\">";
            print "| << <a href=\"".$_SERVER['PHP_SELF']."?field=".$field."&auxil=".$auxil."&flag_order=".$flagorpost."&limit=0\" >".ucfirst($strButton['first'])."</a> ";
            print "| < <a href=\"".$_SERVER['PHP_SELF']."?field=".$field."&auxil=".$auxil."&flag_order=".$flagorpost."&limit=$prev\">".ucfirst($strButton['prev'])."</a> ";
            print "| <a href=\"".$_SERVER['PHP_SELF']."?field=".$field."&auxil=".$auxil."&flag_order=".$flagorpost."&limit=$next\">".ucfirst($strButton['next'])."</a> > ";
            print "| <a href=\"".$_SERVER['PHP_SELF']."?field=".$field."&auxil=".$auxil."&flag_order=".$flagorpost."&limit=$this->last\">".ucfirst($strButton['last'])."</a> >> |";
            print "</div>";
        }
    }
}

// classe per la creazione di headers cliccabili per l'ordinamento dei record
// accetta come parametro un array associativo composto dalle label e relativi campi del db
class linkHeaders
{
    var $headers = array(); // label e campi degli headers
    function linkHeaders($headers)
    {
        $this->headers = $headers;
    }
    function output()
    {
        global $flag_order, $strButton, $auxil, $headers;
        foreach($this->headers as $header => $field) {
            if (!$field == "") {
                print "\t<th class=\"FacetFieldCaptionTD\"><a href=\"".$_SERVER['PHP_SELF']."?field=".$field."&flag_order=".$flag_order."&auxil=".$auxil."\" title=\"".$strButton['order'].$header."\">".$header."</a></th>\n\r";
            } else {
                print "\t<th class=\"FacetFieldCaptionTD\">".$header."</th>\n\r";
            }
        }
    }
}

function cleanMemberSession($abilit, $login, $password, $count, $enterprise_id)
{
    global $gTables;
    $_SESSION["Abilit"] = true;
    $_SESSION["Login"] = $login;
    $_SESSION["Password"] = $password;
    $_SESSION["logged_in"] = true;
    $_SESSION["enterprise_id"] = $enterprise_id;
    $count++;
    //incremento il contatore d'accessi
    putRow($gTables['admin'], "Login",$login,"Access",$count);
}

function checkAdmin($Livaut=0)
{
    global $gTables, $module;

    $_SESSION["logged_in"] = false;
    $_SESSION["Abilit"] = false;

    // Se utente non  loggato lo mandiamo alla pagina di login
    if ((! isset ($_SESSION["Login"])) or ($_SESSION["Login"] == "Null")) {
        $_SESSION["Login"]= "Null";
        header("Location: ../root/login_admin.php");
        exit;
    }
    if (checkAccessRights($_SESSION["Login"], $module) == 0) {
        // Se utente non ha il diritto di accedere al modulo, lo mostriamo
        // il messaggio di errore, ma senza obligarlo di fare un altro (inutile) login
        header("Location: ../root/access_error.php?module=".$module);
        exit;
    }
    $club_row = getRow($gTables['admin'], "Login", $_SESSION["Login"]);
    if ($Livaut > $club_row["Abilit"]) {
        header("Location: ../root/login_admin.php");
        exit;
    } else {
        $_SESSION["Abilit"] = true;
    }

    if (!$club_row || $club_row["Password"] != $_SESSION["Password"]) {
        header("Location: ../root/login_admin.php");
        exit;
    }
    $_SESSION["logged_in"] = true;
    return $club_row;
}

/* controllo se ho delle funzioni specifiche per il modulo corrente
     nella directory /inc  il cui nome deve rispettare questo standard:
     nome_modulo.function.php
*/
if(file_exists('../../library/include/'.$module.'.function.php')) {
    require_once('../../library/include/'.$module.'.function.php');
}
/* controllo se ho delle funzioni specifiche per il modulo corrente
     residente nella directory del module stesso, con queste caratteristiche:
     function.inc.php e deve risiedere nella dir  es.
     modules/nome_modulo/function.inc.php
*/
if(file_exists('function.inc.php')) {
    require_once('function.inc.php');
}
?>