<?php
/* $Id: magazz.function.php,v 1.6 2008/11/06 14:42:00 devincen Exp $
 --------------------------------------------------------------------------
                            Gazie - Gestione Azienda
    Copyright (C) 2004-2008 - Antonio De Vincentiis Montesilvano (PE)
                                (www.devincentiis.it)
                        <http://gazie.sourceforge.net>
 --------------------------------------------------------------------------
    Questo programma e` free software;   e` lecito redistribuirlo  e/o
    modificarlo secondo i  termini della Licenza Pubblica Generica GNU
    come e` pubblicata dalla Free Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.

    Questo programma  e` distribuito nella speranza  che sia utile, ma
    SENZA   ALCUNA GARANZIA; senza  neppure  la  garanzia implicita di
    NEGOZIABILITA` o di  APPLICABILITA` PER UN  PARTICOLARE SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.

    Ognuno dovrebbe avere   ricevuto una copia  della Licenza Pubblica
    Generica GNU insieme a   questo programma; in caso  contrario,  si
    scriva   alla   Free  Software Foundation,  Inc.,   59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA Stati Uniti.
 --------------------------------------------------------------------------
*/

// classe per le interazioni con il magazzino
class interactMag
{
  function getOperators()  // Creo l'array associativo degli operatori dei documenti
  {
        return array ("VCO" => -1,"DDT" => -1,"FAD" => -1,"FAI" => -1,"FNC" => 1,"FND" => 0,
                      "DDR" => -1,"DDL" => -1,"AFA" => 1,"ADT" => 1,"AFC" => -1, "VPR" => 0, "VOR" => -1);
  }
  function getStockEvalMethod()  // Prendo il metodo di valorizzazione del magazzino impostato in configurazione azienda
  {
      global $gTables;
      $enterprise = getRow($gTables['aziend'],'codice',$_SESSION['enterprise_id']);
      return $enterprise['stock_eval_method'];
  }
  function getLastCost($item_code,$decimal_price)  // Prendo il costo dall'ultimo movimento d'aquisto
  {
      global $gTables;
      $rs_last_cost = dynQuery("*", $gTables['movmag'], " artico = '$item_code' AND tipdoc LIKE 'A%' AND operat = 1 ","datreg DESC, id_mov DESC",0,1);
      $last_cost = dbms_fetch_array($rs_last_cost);
      if ($last_cost) {
         return CalcolaImportoRigo(1,$last_cost['prezzo'],array($last_cost['scochi'],$last_cost['scorig']),$decimal_price);
      } else {
         return 0;
      }
  }
  function ctrlMovYearsAfter($year,$item_code)  // Controllo che non ci siano movimenti negli anni successivi
  {
      global $gTables;
      $rs_years_after = dynQuery("*", $gTables['movmag'], "YEAR(datreg) > $year AND artico = '$item_code' AND tipdoc LIKE 'A%' AND operat = 1 ","datreg DESC, id_mov DESC",0,1);
      $years_after = dbms_fetch_array($rs_years_after);
      if ($years_after) {
          return false;   // non si pu aggiornare il valore dell'esistente perch ci sono movimenti su anni successivi
      } else {
          return true;
      }
  }
  function updateStockValue($item_code,$year=null,$stock_eval_method=null)    //Aggiorno il valore dell'esistente
  {
     global $gTables;
     $azienda = getRow($gTables['aziend'],'codice',1);
     if (!$year){
        $year=date("Y");
     }
     $year = substr($year,0,4);
     if (!$stock_eval_method){
        $stock_eval_method = $this->getStockEvalMethod();
     }
     $new_value = null;
     $last_cost = 'last_cost';
     $where = "YEAR(datreg) = $year AND artico = '$item_code' AND operat = 1 AND caumag < 99";
     if ($this->ctrlMovYearsAfter($year,$item_code)) { //controllo che non ci siano movimenti in anni successivi
        switch ($stock_eval_method) { //calcolo il nuovo valore in base al metodo scelto in configurazione azienda
            case "0": //standard
            case "3": // FIFO
                 $rs_last_movmag = dynQuery("*", $gTables['movmag'], $where,"datreg DESC, id_mov DESC",0,1);
                 $last_movmag = dbms_fetch_array($rs_last_movmag);
                 if ($last_movmag) {
                    $new_value = CalcolaImportoRigo(1,$last_movmag['prezzo'],array($last_movmag['scochi'],$last_movmag['scorig']),$azienda['decimal_price']);
                 }
            break;
            case "1": // WMA
                 $rs_year_movmag = dynQuery("SUM((prezzo-prezzo*(scochi+(scorig-scochi*scorig/100))/100)*quanti*operat) AS value_sum , SUM(quanti*operat) AS quanti_sum ", $gTables['movmag'], "YEAR(datreg) = $year AND artico = '$item_code' AND operat = 1 GROUP BY artico","datreg DESC, id_mov DESC");
                 $year_movmag = dbms_fetch_array($rs_year_movmag);
                 if ($year_movmag) {
                    $new_value = $year_movmag['value_sum']/$year_movmag['quanti_sum'];
                 }
            break;
            case "2": // LIFO
                 $rs_first_movmag = dynQuery("*", $gTables['movmag'], $where,"datreg ASC, id_mov ASC",0,1);
                 $first_movmag = dbms_fetch_array($rs_first_movmag);
                 if ($first_movmag) {
                     $new_value = CalcolaImportoRigo(1,$first_movmag['prezzo'],array($first_movmag['scochi'],$first_movmag['scorig']),$azienda['decimal_price']);
                 }
            break;
            default:
              $new_value = null;
        }
        $last_cost = $this->getLastCost($item_code,$azienda['decimal_price']);
     }
     if ($new_value) {
        dbms_query ("UPDATE ".$gTables['artico']." SET valore = esiste * $new_value, last_cost = $last_cost WHERE `codice` = '".$item_code."';");
     }
     return $new_value;
  }
  function uploadMag($id_rigo_doc=0,$tipdoc,$numdoc,$seziva,$datdoc,$clfoco,$sconto_chiusura,$caumag,$codart,$quantita,$prezzo,$sconto_rigo,$id_movmag=0,$stock_eval_method=null,$data_from_admin_mov=false)  // su id_rigo_doc 0 per inserire 1 o + per fare l'upload 'DEL' per eliminare il movimento
  {
        // in $data_from_admin_mov  ci sono i dati in pi provenienti da admin_movmag (desdoc,operat, id_rif)
        global $gTables;
        global $money;
        $docOperat = $this->getOperators();
        if ($tipdoc == 'FAD'){  // per il magazzino una fattura differita  come dire DDT
            $tipdoc = 'DDT';
        }
        if (substr($tipdoc,0,1) == 'A' or $tipdoc == 'DDR' or $tipdoc == 'DDL'){ //documento di acquisto
          require_once("../../language/".getUserLang($money)."/acquis.inc.php");
          $desdoc=addslashes($strScript['admin_docacq.php'][0][$tipdoc]);
        } else { //documento di vendita
          require_once("../../language/".getUserLang($money)."/vendit.inc.php");
          $desdoc=addslashes($strScript['admin_docven.php'][0][$tipdoc]);
        }
        if (substr($tipdoc,0,1) == 'D'){
          $desdoc .= " n.".$numdoc;
        } else {
          $desdoc .= " n.".$numdoc." prot.".$seziva;
        }
        $new_caumag = getRow($gTables['caumag'],'codice',$caumag);
        $operat = $new_caumag['operat'];
        if (!$data_from_admin_mov){         // se viene da un documento
           $datreg = $datdoc;               // la data di registrazione coincide con quella del documento
           $operat = $docOperat[$tipdoc];    // e la descrizione la ricavo dal tipo documento
        } else {                            // se  stato passato l'array dei dati
           $datreg = $data_from_admin_mov['datreg']; // prendo la descrizione e l'operatore da questo
           $operat = $data_from_admin_mov['operat'];
           $desdoc = $data_from_admin_mov['desdoc'];
        }
        $row_movmag = array('caumag'=>$caumag,
                            'operat'=>$operat,
                            'datreg'=>$datreg,
                            'tipdoc'=>$tipdoc,
                            'desdoc'=>$desdoc,
                            'datdoc'=>$datdoc,
                            'clfoco'=>$clfoco,
                            'scochi'=>$sconto_chiusura,
                            'id_rif'=>$id_rigo_doc,
                            'artico'=>$codart,
                            'quanti'=>$quantita,
                            'prezzo'=>$prezzo,
                            'scorig'=>$sconto_rigo );
        if ($id_movmag == 0) {                             // si deve inserire un nuovo movimento
           movmagInsert($row_movmag);
           $ultimo_id_mm = ultimoID(); //id del rigo movimento magazzino
           putRow($gTables['rigdoc'], 'id_rig', $id_rigo_doc, 'id_mag', ultimoID());
           $upd_art_exist_value = $quantita*$operat*$new_caumag['upesis'];
        } elseif ($id_movmag > 0 && $id_rigo_doc != 'DEL') {   // si deve modificare un movimento esistente
            $old_movmag = getRow($gTables['movmag'],'id_mov',$id_movmag);
            $old_caumag = getRow($gTables['caumag'],'codice',$old_movmag['caumag']);
            $id = array('id_mov',$id_movmag);
            if (!isset($new_caumag['operat'])){
               $new_caumag['operat'] = 0;
            }
            if (!isset($old_caumag['operat'])){
               $old_caumag['operat'] = 0;
            }
            movmagUpdate($id,$row_movmag);
            // detraggo il valore del movimento precedente dall'esistente dell'articolo precedente
            $upd_old_art_exist_value =  $old_movmag['quanti']*$old_movmag['operat']*$old_caumag['upesis'];
            dbms_query ("UPDATE ".$gTables['artico']." SET esiste = esiste - ".$upd_old_art_exist_value." WHERE `codice` = '".$old_movmag['artico']."';");
            // poi aggiungo il nuovo
            $upd_art_exist_value = $quantita*$operat*$new_caumag['upesis'];
        } elseif ($id_rigo_doc == 'DEL') {                 // si deve eliminare un movimento esistente
            $old_movmag = getRow($gTables['movmag'],'id_mov',$id_movmag);
            $old_caumag = getRow($gTables['caumag'],'codice',$old_movmag['caumag']);
            delRow($gTables['movmag'], 'id_mov', $id_movmag);
            $upd_art_exist_value =  - $old_movmag['quanti']*$old_movmag['operat']*$old_caumag['upesis'];
            $codart = $old_movmag['artico'] ;
        }
        dbms_query ("UPDATE ".$gTables['artico']." SET esiste = esiste + ".$upd_art_exist_value." WHERE `codice` = '".$codart."';");
        $this->updateStockValue($codart,$datreg,$stock_eval_method);
  }
}

?>