<?php
 /* $Id: expired_calc.inc.php,v 1.2 2008/10/13 15:18:58 devincen Exp $
 --------------------------------------------------------------------------
                            Gazie - Gestione Azienda
    Copyright (C) 2004-2008 - Antonio De Vincentiis Montesilvano (PE)
                                (www.devincentiis.it)
                        <http://gazie.sourceforge.net>
 --------------------------------------------------------------------------
    Questo programma e` free software;   e` lecito redistribuirlo  e/o
    modificarlo secondo i  termini della Licenza Pubblica Generica GNU
    come e` pubblicata dalla Free Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.

    Questo programma  e` distribuito nella speranza  che sia utile, ma
    SENZA   ALCUNA GARANZIA; senza  neppure  la  garanzia implicita di
    NEGOZIABILITA` o di  APPLICABILITA` PER UN  PARTICOLARE SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.

    Ognuno dovrebbe avere   ricevuto una copia  della Licenza Pubblica
    Generica GNU insieme a   questo programma; in caso  contrario,  si
    scriva   alla   Free  Software Foundation,  Inc.,   59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA Stati Uniti.
 --------------------------------------------------------------------------
*/

function expiry_date_calc($totpag,$giorno,$mese,$anno,$tipdec,$giodec,$numrat,$tiprat,$mesesc,$giosuc)
    {
    /* $totpag,$giorno,$mese,$anno,$tipdec,$giodec,$numrat,$tiprat,$mesesc,$giosuc
       INPUT:
       A questa funzione dev'essere passato come referenza un array monodimensionale con i seguenti index:
       'total' = importo da pocessare in base alle successive impostazioni DECIMAL X,2
       'date' = data base di calcolo (in genere quella del documento) AAAA-MM-GG
       'date_ref' = tipo di decorrenza pu assumere i valori: 'D'= data documento,
                                                              'G'= giorno dell'elemento 'day_ref',
                                                              'F'= ultimo giorno del mese
       'day_ref' = giorno fisso di decorrenza
       'n_instalments' = numero di rate
       'instalments_type' = tipo di rate
       'exclud_month' = mese escluso
       'exclud_day' = giorno escluso

       OUTPUT:
       Array bidimensionale contenente le date e gli importi delle scadenze:
       'date' = AAAA-MM-GG data di scadenza della rata
       'value' = importo della rata

    */
    //azzero le variabili
    if (! isset( $tiprat)){
       $tiprat="";
       }
    $parzia = "";
    $ratpag = array();
    for( $counter = 1; $counter <= $numrat; $counter++ ){
       if ($counter < $numrat and $numrat > 1){
          $ratpag['import'][$counter] = number_format (($totpag / $numrat),2, '.', '');
       } else if ($counter == $numrat and $numrat == 1) {
          $ratpag['import']['1'] = number_format ($totpag,2, '.', '');
       } else if ($counter == $numrat and $numrat > 1) {
          $ratpag['import'][$counter] = number_format(($totpag - $parzia),2, '.', '');
       }
       $parzia = $ratpag['import'][$counter] + $parzia;
       }

       //e il calcolo delle date di scadenza ...
       //a secondo del tipo di decorrenza ...
    switch($tipdec) {
          case "D": //caso in cui la scadenza deve far riferimento alla data della fattura
          $utsdatin = mktime(0,0,0,$mese,$giorno + $giodec,$anno);
          $giorin = strftime("%d",$utsdatin);
          $mesein = strftime("%m",$utsdatin);
          $annoin = strftime("%Y",$utsdatin);
          if ($mesesc > 0 and $mesesc == $mesein) {
             $mesdat = $mesein + 1;
          } else {
             $mesdat = $mesein;
          }
          $utsdatfat = mktime(0,0,0,$mesdat,$giorin,$annoin);
          $ratpag['giorno']['1'] = strftime("%d",$utsdatfat);
          $ratpag['mese']['1'] = strftime("%m",$utsdatfat);
          $ratpag['anno']['1'] = strftime("%Y",$utsdatfat);

          //creo le eventuali date successive
          $ctrlmese = $mesdat;
          for ($counter = 2; $counter <= $numrat ; $counter++ ) {
              switch($tiprat) {
                    case "Q":
                    if ($mesesc > 0 and $mesesc == $ctrlmese) {
                        $ctrlmese++;
                    }
                    if ($counter % 2 == 0) {
                        $giorin = 15;
                    } else {
                        $ctrlmese++;
                        $giorin = 0;
                    }
                    $utsdatfat = mktime(0,0,0,$ctrlmese,$giorin,$annoin);
                    $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                    $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                    $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                    break;

                    case "M":
                    $ctrlmese++;
                    if ($mesesc > 0 and $mesesc == $ctrlmese) {
                        $ctrlmese++;
                    }
                    $utsdatfat = mktime(0,0,0,$ctrlmese,$giorno,$annoin);
                    $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                    $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                    $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                    break;

                    case "B":
                    $ctrlmese = $mesein + 2*($counter-1) + 1;
                    if ($mesesc > 0 and $mesesc == $ctrlmese ) {
                        $ctrlmese++;
                    }
                    $utsdatfat = mktime(0,0,0,$ctrlmese,$giorno,$annoin);
                    $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                    $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                    $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                    break;

                    case "T":
                    $ctrlmese = $mesein + 3*($counter-1) + 1;
                    if ($mesesc > 0 and $mesesc == ($ctrlmese - 1)) {
                        $ctrlmese++;
                    }
                    $utsdatfat = mktime(0,0,0,$ctrlmese,$giorno,$annoin);
                    $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                    $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                    $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                    break;

                    case "U":
                    $ctrlmese = $mesein + 4*($counter-1) + 1;
                    if ($mesesc > 0 and $mesesc == ($ctrlmese - 1)) {
                        $ctrlmese++;
                    }
                    $utsdatfat = mktime(0,0,0,$ctrlmese,$giorno,$annoin);
                    $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                    $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                    $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                    break;

                    case "E":
                    $ctrlmese = $mesein + 6*($counter-1) + 1;
                    if ($mesesc > 0 and $mesesc == ($ctrlmese - 1)) {
                        $ctrlmese++;
                    }
                    $utsdatfat = mktime(0,0,0,$ctrlmese,$giorno,$annoin);
                    $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                    $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                    $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                    break;

                    case "A":
                    $ctrlmese = $mesein + 12*($counter-1) + 1;
                    if ($mesesc > 0 and $mesesc == ($ctrlmese - 1)) {
                        $ctrlmese++;
                    }
                    $utsdatfat = mktime(0,0,0,$ctrlmese,$giorno,$annoin);
                    $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                    $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                    $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                    break;
              }
          }
          break;

          case "G": //caso in cui la scadenza deve far riferimento al giorno fisso impostato sul relativo campo
          $utsdatfm = mktime(0,0,0,$mese,$giorno+$giodec,$anno);
          $mesefm = strftime("%m",$utsdatfm);
          $annofm = strftime("%Y",$utsdatfm);
          $utsdatin = mktime(0,0,0,$mesefm + 1,0,$annofm);
          $giorin = strftime("%d",$utsdatin);
          $mesein = strftime("%m",$utsdatin);
          $annoin = strftime("%Y",$utsdatin);
          $giodat = $giorin + $giosuc;
          if ($mesesc > 0 and $mesesc == $mesein) {
              $mesdat = $mesein + 1;
          } else {
              $mesdat = $mesein ;
          }
          $utsdatfat = mktime(0,0,0,$mesdat,$giodat,$annoin);
          $ratpag['giorno']['1'] = strftime("%d",$utsdatfat);
          $ratpag['mese']['1'] = strftime("%m",$utsdatfat);
          $ratpag['anno']['1'] = strftime("%Y",$utsdatfat);

          //creo le eventuali date successive
          $ctrlmese = $mesein +1;
          for( $counter = 2; $counter <= $numrat ; $counter++ ) {
              switch($tiprat) {
                     case "Q":
                     if ($mesesc > 0 and $mesesc == $ctrlmese) {
                         $ctrlmese++;
                     }
                     if ($counter % 2 == 0) {
                         $giorin = 15;
                     } else {
                     $ctrlmese++;
                     $giorin = 0;
                     }
                     $utsdatfat = mktime(0,0,0,$ctrlmese,$giorin,$annoin);
                     $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                     $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                     $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                     break;

                     case "M":
                     $ctrlmese++;
                     if ($mesesc > 0 and $mesesc == $ctrlmese) {
                         $ctrlmese++;
                     }
                     $utsdatfat = mktime(0,0,0,$ctrlmese,$giosuc,$annoin);
                     $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                     $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                     $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                     break;

                     case "B":
                     $ctrlmese = $mesein + 2*($counter-1) + 1;
                     if ($mesesc > 0 and $mesesc == $ctrlmese ) {
                         $ctrlmese++;
                     }
                     $utsdatfat = mktime(0,0,0,$ctrlmese,$giosuc,$annoin);
                     $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                     $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                     $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                     break;

                     case "T":
                     $ctrlmese = $mesein + 3*($counter-1) + 1;
                     if ($mesesc > 0 and $mesesc == ($ctrlmese - 1)) {
                         $ctrlmese++;
                     }
                     $utsdatfat = mktime(0,0,0,$ctrlmese,$giosuc,$annoin);
                     $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                     $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                     $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                     break;

                     case "U":
                     $ctrlmese = $mesein + 4*($counter-1) + 1;
                     if ($mesesc > 0 and $mesesc == ($ctrlmese - 1)) {
                         $ctrlmese++;
                     }
                     $utsdatfat = mktime(0,0,0,$ctrlmese,$giosuc,$annoin);
                     $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                     $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                     $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                     break;

                     case "E":
                     $ctrlmese = $mesein + 6*($counter-1) + 1;
                     if ($mesesc > 0 and $mesesc == ($ctrlmese - 1)) {
                         $ctrlmese++;
                     }
                     $utsdatfat = mktime(0,0,0,$ctrlmese,$giosuc,$annoin);
                     $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                     $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                     $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                     break;

                     case "A":
                     $ctrlmese = $mesein + 12*($counter-1) + 1;
                     if ($mesesc > 0 and $mesesc == ($ctrlmese - 1)) {
                         $ctrlmese++;
                     }
                     $utsdatfat = mktime(0,0,0,$ctrlmese,$giosuc,$annoin);
                     $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                     $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                     $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                     break;
              }
          }
          break;

          case "F": //caso in cui la scadenza deve far riferimento al fine mese rispetto alla data della fattura

          //bug segnalato da lapini correzione di de vincentiis del 18.03.2005
          //se la data iniziale e' gennaio bisogna togliere 2 giorni alla decorrenza per compensare i 28gg di febbraio
          if ($mese == 1) {
              $giodec -=2;
          } //fine debug
          $utsdatfm = mktime(0,0,0,$mese,$giorno+$giodec,$anno);
          $mesefm = strftime("%m",$utsdatfm);
          $annofm = strftime("%Y",$utsdatfm);
          $utsdatin = mktime(0,0,0,$mesefm + 1,0,$annofm);
          $giorin = strftime("%d",$utsdatin);
          $mesein = strftime("%m",$utsdatin);
          $annoin = strftime("%Y",$utsdatin);
          if ($mesesc > 0 and $mesesc == $mesein) {
              $giodat = $giosuc;
              $mesdat = $mesein +1 ;
          } else {
              $giodat = $giorin ;
              $mesdat = $mesein ;
          }
          $utsdatfat = mktime(0,0,0,$mesdat,$giodat,$annoin);
          $ratpag['giorno']['1'] = strftime("%d",$utsdatfat);
          $ratpag['mese']['1'] = strftime("%m",$utsdatfat);
          $ratpag['anno']['1'] = strftime("%Y",$utsdatfat);

          //creo le eventuali date successive
          $ctrlmese = $mesein +1;
          for( $counter = 2; $counter <= $numrat ; $counter++ ) {
              switch($tiprat) {
                     case "Q":
                     if ($mesesc > 0 and $mesesc == $ctrlmese) {
                         $ctrlmese++;
                     }
                     if ($counter % 2 == 0) {
                         $giorin = 15;
                     } else {
                     $ctrlmese++;
                     $giorin = 0;
                     }
                     $utsdatfat = mktime(0,0,0,$ctrlmese,$giorin,$annoin);
                     $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                     $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                     $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                     break;

                     case "M":
                     $ctrlmese = $mesein + $counter;
                     $giorin = 0;
                     if ($mesesc > 0 and $mesesc == ($ctrlmese-1)) {
                         $giorin = $giosuc;
                     }
                     $utsdatfat = mktime(0,0,0,$ctrlmese,$giorin,$annoin);
                     $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                     $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                     $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                     break;

                     case "B":
                     $ctrlmese = $mesein + 2*($counter-1) + 1;
                     $giorin = 0;
                     if ($mesesc > 0 and $mesesc == ($ctrlmese - 1)) {
                         $giorin = $giosuc;
                     }
                     $utsdatfat = mktime(0,0,0,$ctrlmese,$giorin,$annoin);
                     $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                     $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                     $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                     break;

                     case "T":
                     $ctrlmese = $mesein + 3*($counter-1) + 1;
                     $giorin = 0;
                     if ($mesesc > 0 and $mesesc == ($ctrlmese - 1)) {
                         $giorin = $giosuc;
                     }
                     $utsdatfat = mktime(0,0,0,$ctrlmese,$giorin,$annoin);
                     $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                     $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                     $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                     break;

                     case "U":
                     $ctrlmese = $mesein + 4*($counter-1) + 1;
                     $giorin = 0;
                     if ($mesesc > 0 and $mesesc == ($ctrlmese - 1)) {
                         $giorin = $giosuc;
                     }
                     $utsdatfat = mktime(0,0,0,$ctrlmese,$giorin,$annoin);
                     $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                     $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                     $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                     break;

                     case "E":
                     $ctrlmese = $mesein + 6*($counter-1) + 1;
                     $giorin = 0;
                     if ($mesesc > 0 and $mesesc == ($ctrlmese - 1)) {
                         $giorin = $giosuc;
                     }
                     $utsdatfat = mktime(0,0,0,$ctrlmese,$giorin,$annoin);
                     $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                     $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                     $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                     break;

                     case "A":
                     $ctrlmese = $mesein + 12*($counter-1) + 1;
                     $giorin = 0;
                     if ($mesesc > 0 and $mesesc == ($ctrlmese - 1)) {
                         $giorin = $giosuc;
                     }
                     $utsdatfat = mktime(0,0,0,$ctrlmese,$giorin,$annoin);
                     $ratpag['giorno'][$counter] = strftime("%d",$utsdatfat);
                     $ratpag['mese'][$counter] = strftime("%m",$utsdatfat);
                     $ratpag['anno'][$counter] = strftime("%Y",$utsdatfat);
                     break;
                }
            }
            break;
    }
    return $ratpag;
}

function createArrayCrediti($result,$pagame,$utsval) {
    // la variabile $result deve contenere tutti i movimenti tranne quelli di chiusura
    // scopo di questa funzione e' quella di creare l'array dei CREDITI vantati verso il cliente in base
    // alla condizione di pagamento passata tramite la seconda variabile.
    $parzi = 0.00;
    $progr = 0.00;
    $righiCrediti = array();
    $rigo = 0;
    $ctrlapertura = ""; //per prendere in considerazione solo il primo movimento d'apertura
    while ($movimenti = dbms_fetch_array($result)) {
      if ($movimenti["caucon"] != 'APE' or empty($ctrlapertura)) { //questo per eliminare tutti i movimenti di apertura successivi il primo
        if ($movimenti["darave"] == 'A') {
            if($progr >= 0) {
               $progr += $movimenti["import"];
            }
            if($progr < 0 and $progr >= -$movimenti["import"]) {
               $progr += $movimenti["import"];
               //questo per eliminare tutti gli array
               $righiCrediti = array();
               $rigo = 0;
            }
            if($progr < 0 and $progr < -$movimenti["import"]) {
               $parzi = $movimenti["import"];
               $progr += $movimenti["import"];
               foreach ($righiCrediti as $key => $value) {
                  if ($parzi >= $value['import']) {
                       array_shift($righiCrediti);
                       $rigo--;
                       $parzi -= $value['import'];
                  }
                  elseif ($parzi > 0) {
                       $righiCrediti[0]['import'] = $value['import'] - $parzi; //questo elimina il resto dell'elemento
                       $parzi = 0.00;
                  }
               }
            }
        } else {
            if($progr <= 0) {
               $giodoc = substr($movimenti['datdoc'],8,2);
               $mesdoc = substr($movimenti['datdoc'],5,2);
               $anndoc = substr($movimenti['datdoc'],0,4);
               $utsdoc = mktime(0,0,0,$mesdoc,$giodoc,$anndoc);
               $ratpag = CalcolaScadenze($movimenti['import'],$giodoc,$mesdoc,$anndoc,$pagame['tipdec'],$pagame['giodec'],$pagame['numrat'],$pagame['tiprat'],$pagame['mesesc'],$pagame['giosuc']);
               foreach ($ratpag['import'] as $key => $value) {
                    $utssca = mktime(0,0,0,$ratpag['mese'][$key],$ratpag['giorno'][$key],$ratpag['anno'][$key]);
                    if ($utssca <= $utsval) {
                       $righiCrediti[$rigo]['id_rig'] = $movimenti['id_rig'];
                       $righiCrediti[$rigo]['import'] = $value-$parzi;
                       switch($movimenti['operat']) {
                               case 1:
                               case 2:
                               $righiCrediti[$rigo]['descri'] = substr($movimenti['descri'],0,18)." N.".$movimenti['numdoc']." DEL ".$giodoc."-".$mesdoc."-".$anndoc;
                               break;
                               default:
                               $righiCrediti[$rigo]['descri'] = "";
                               break;
                       }
                       $rigo++;
                       $progr -= $value;
                    } else {
                       $progr -= $value;
                    }
               }
            }
            if($progr > 0 and $progr < $movimenti['import']) {
               $giodoc = substr($movimenti['datdoc'],8,2);
               $mesdoc = substr($movimenti['datdoc'],5,2);
               $anndoc = substr($movimenti['datdoc'],0,4);
               $utsdoc = mktime(0,0,0,$mesdoc,$giodoc,$anndoc);
               $ratpag = CalcolaScadenze($movimenti['import'],$giodoc,$mesdoc,$anndoc,$pagame['tipdec'],$pagame['giodec'],$pagame['numrat'],$pagame['tiprat'],$pagame['mesesc'],$pagame['giosuc']);
               $parzi = $progr;
               foreach ($ratpag['import'] as $key => $value) {
                    $utssca = mktime(0,0,0,$ratpag['mese'][$key],$ratpag['giorno'][$key],$ratpag['anno'][$key]);
                    if ($utssca <= $utsval)  {
                       if ($progr < $value) {
                          $righiCrediti[$rigo]['id_rig'] = $movimenti['id_rig'];
                          $righiCrediti[$rigo]['import'] = $value-$parzi;
                          switch($movimenti['operat']) {
                               case 1:
                               case 2:
                               $righiCrediti[$rigo]['descri'] = substr($movimenti['descri'],0,18)." N.".$movimenti['numdoc']." DEL ".$giodoc."-".$mesdoc."-".$anndoc;
                               break;
                               default:
                               $righiCrediti[$rigo]['descri'] = "";
                               break;
                          }
                          $rigo++;
                          $parzi = 0.00;
                          $progr -= $value;
                       } else {
                          $progr -= $value;
                          $parzi -= $value;
                       }
                    } else {
                       $parzi = 0.00;
                       $progr -= $value;
                    }
               }
            }
            if($progr > 0 and $progr >= $movimenti['import']) {
               $progr -= $movimenti["import"];
            }
        }
      }
      if ($movimenti["caucon"] == 'APE') {
         $ctrlapertura = $movimenti["caucon"] ;
      }
    } //fine while
    $righiCrediti['numrighi'] = $rigo;
    return $righiCrediti;
}

function createArrayDebiti($result,$pagame,$utsval) {
    // scopo di questa funzione e' quella di creare l'array dei DEBITI verso il fornitore in base
    // alla condizione di pagamento passata tramite la seconda variabile.
    $parzi = 0.00;
    $progr = 0.00;
    $righiDebiti = array();
    $rigo = 0;
    while ($movimenti = dbms_fetch_array($result)) {
        if ($movimenti["darave"] == 'D') {
            if($progr >= 0) {
               $progr += $movimenti["import"];
            }
            if($progr < 0 and $progr >= -$movimenti["import"]) {
               $progr += $movimenti["import"];
               //questo per eliminare tutti gli array
               $righiDebiti = array();
               $rigo = 0;
            }
            if($progr < 0 and $progr < -$movimenti["import"]) {
               $parzi = $movimenti["import"];
               $progr += $movimenti["import"];
               foreach ($righiDebiti as $key => $value) {
                  if ($parzi >= $value['import']) {
                       array_shift($righiDebiti);
                       $rigo--;
                       $parzi -= $value['import'];
                  }
                  elseif ($parzi > 0) {
                       $righiDebiti[0]['import'] = $value['import'] - $parzi; //questo elimina il resto dell'elemento
                       $parzi = 0.00;
                  }
               }
            }
        } else {
            if($progr <= 0) {
               $giodoc = substr($movimenti['datdoc'],8,2);
               $mesdoc = substr($movimenti['datdoc'],5,2);
               $anndoc = substr($movimenti['datdoc'],0,4);
               $utsdoc = mktime(0,0,0,$mesdoc,$giodoc,$anndoc);
               $ratpag = CalcolaScadenze($movimenti['import'],$giodoc,$mesdoc,$anndoc,$pagame['tipdec'],$pagame['giodec'],$pagame['numrat'],$pagame['tiprat'],$pagame['mesesc'],$pagame['giosuc']);
               foreach ($ratpag['import'] as $key => $value) {
                    $utssca = mktime(0,0,0,$ratpag['mese'][$key],$ratpag['giorno'][$key],$ratpag['anno'][$key]);
                    if ($utssca <= $utsval) {
                       $righiDebiti[$rigo]['import'] = $value-$parzi;
                       switch($movimenti['caucon']) {
                               case "AFA":
                               $righiDebiti[$rigo]['descri'] = "FATTURA N.".$movimenti['numdoc']." DEL ".$giodoc."-".$mesdoc."-".$anndoc;
                               break;
                               case "AND":
                               $righiDebiti[$rigo]['descri'] = "NOTA DEBITO N.".$movimenti['numdoc']." DEL ".$giodoc."-".$mesdoc."-".$anndoc;
                               break;
                               case "ANC":
                               $righiDebiti[$rigo]['descri'] = "NOTA CREDITO N.".$movimenti['numdoc']." DEL ".$giodoc."-".$mesdoc."-".$anndoc;
                               break;
                               default:
                               $righiDebiti[$rigo]['descri'] = "DOCUMENTO N.".$movimenti['numdoc']." DEL ".$giodoc."-".$mesdoc."-".$anndoc;
                               break;
                       }
                       $rigo++;
                       $progr -= $value;
                    } else {
                       $progr -= $value;
                    }
               }
            }
            if($progr > 0 and $progr < $movimenti['import']) {
               $giodoc = substr($movimenti['datdoc'],8,2);
               $mesdoc = substr($movimenti['datdoc'],5,2);
               $anndoc = substr($movimenti['datdoc'],0,4);
               $utsdoc = mktime(0,0,0,$mesdoc,$giodoc,$anndoc);
               $ratpag = CalcolaScadenze($movimenti['import'],$giodoc,$mesdoc,$anndoc,$pagame['tipdec'],$pagame['giodec'],$pagame['numrat'],$pagame['tiprat'],$pagame['mesesc'],$pagame['giosuc']);
               $parzi = $progr;
               foreach ($ratpag['import'] as $key => $value) {
                    $utssca = mktime(0,0,0,$ratpag['mese'][$key],$ratpag['giorno'][$key],$ratpag['anno'][$key]);
                    if ($utssca <= $utsval)  {
                       if ($progr < $value) {
                          $righiDebiti[$rigo]['import'] = $value-$parzi;
                          switch($movimenti['caucon']) {
                               case "AFA":
                               $righiDebiti[$rigo]['descri'] = "FATTURA N.".$movimenti['numdoc']." DEL ".$giodoc."-".$mesdoc."-".$anndoc;
                               break;
                               case "AND":
                               $righiDebiti[$rigo]['descri'] = "NOTA DEBITO N.".$movimenti['numdoc']." DEL ".$giodoc."-".$mesdoc."-".$anndoc;
                               break;
                               case "ANC":
                               $righiDebiti[$rigo]['descri'] = "NOTA CREDITO N.".$movimenti['numdoc']." DEL ".$giodoc."-".$mesdoc."-".$anndoc;
                               break;
                               default:
                               $righiDebiti[$rigo]['descri'] = "DOCUMENTO N.".$movimenti['numdoc']." DEL ".$giodoc."-".$mesdoc."-".$anndoc;
                               break;
                          }
                          $rigo++;
                          $parzi = 0.00;
                          $progr -= $value;
                       } else {
                          $progr -= $value;
                          $parzi -= $value;
                       }
                    } else {
                       $parzi = 0.00;
                       $progr -= $value;
                    }
               }
            }
            if($progr > 0 and $progr >= $movimenti['import']) {
               $progr -= $movimenti["import"];
            }
        }
    } //fine while
    $righiCrediti['numrighi'] = $rigo;
    return $righiDebiti;
}
?>