<?php
/* $Id: update_prezzi.php,v 1.18 2008/10/14 08:29:38 devincen Exp $
 --------------------------------------------------------------------------
                            Gazie - Gestione Azienda
    Copyright (C) 2004-2008 - Antonio De Vincentiis Montesilvano (PE)
                                (www.devincentiis.it)
                        <http://gazie.sourceforge.net>
 --------------------------------------------------------------------------
    Questo programma e` free software;   e` lecito redistribuirlo  e/o
    modificarlo secondo i  termini della Licenza Pubblica Generica GNU
    come e` pubblicata dalla Free Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.
    Questo programma  e` distribuito nella speranza  che sia utile, ma
    SENZA   ALCUNA GARANZIA; senza  neppure  la  garanzia implicita di
    NEGOZIABILITA` o di  APPLICABILITA` PER UN  PARTICOLARE SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.
    Ognuno dovrebbe avere   ricevuto una copia  della Licenza Pubblica
    Generica GNU insieme a   questo programma; in caso  contrario,  si
    scriva   alla   Free  Software Foundation,  Inc.,   59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA Stati Uniti.
 --------------------------------------------------------------------------
*/
require_once("../../library/include/datlib.inc.php");
require_once("../../library/include/function.inc.php");
checkAdmin();
$msg = '';
$azienda = getRow($gTables['aziend'],'codice',1);

function compute_new_price($base_price,$obj_price=0,$value=0,$mode='C',$round=3) {
/* calcolo del nuovo prezzo in base ai valori passati come referenza:

$base_price  il prezzo del listino preso a base di calcolo, ovvero il prezzo vecchio
$obj_price  il prezzo del listino da modificare, ovvero il prezzo vecchio (default=0)
$value  il valore di incremento/decremento o percentuale (default=0)
$mode  il tipo di modifica da effettuare e pu assumere i seguenti valori:
      A = sostituzione;
      B = somma in percentuale
      C = somma valore  (default)
      D = moltiplicazione per valore
      E = divisione per valore
      F = azzeramento e somma in percentuale
$round  il numero di decimali per l'arrotondamento (default valore scelto in anagrafica azienda)

*/
    switch ($mode) {
           case 'A': //sostituzione
           $new_price = round($value,$round);
           break;
           case 'B': //somma in percentuale
           $new_price = round($obj_price+$base_price*$value/100,$round);
           break;
           case 'C': //somma valore
           $new_price = round($obj_price+$value,$round);
           break;
           case 'D': //moltiplicazione per valore
           $new_price = round($obj_price*$value,$round);
           break;
           case 'E': //divisione per valore
           $new_price = round($obj_price/$value,$round);
           break;
           case 'F': //azzeramento e somma in percentuale
           $new_price = round($base_price+$base_price*$value/100,$round);
           break;
    }
    return $new_price;
}

if (!isset($_POST['lisobj'])) {
        $form['lisobj'] = 'VE1';
        $form['lisbas'] = 'VE1';
        $form['modali'] = 'C';
        $form['arroto'] = $azienda['decimal_price'];
        $form['valore'] = 0;
        $form['camein'] = '';
        $form['camefi'] = '';
        $form['coarin'] = '';
        $form['coarfi'] = '';
} else {
       // alla faccia di chi mi vuole male, non faccio parsing!
       $form = $_POST;
}
//controllo i campi
if ($form['camein'] > $form['camefi'])
    $msg .='31+';
if ($form['coarin'] > $form['coarfi'])
    $msg .='30+';
if ($form['valore'] == 0 and ($form['modali'] == 'D' or $form['modali'] == 'E'))
    $msg .='29+';
if (isset($_POST['genera']) and $msg == '')
        {
        //Modifico i prezzi di tutti gli articoli selezionati...
        if (empty ($form['coarfi']))
            $form['coarfi'] = 'zzzzzzzzzzzzzzz';
        $orderby = " catmer ASC, codice ASC";
        $where = "codice BETWEEN '".$form['coarin']."' AND '".$form['coarfi']."' AND catmer BETWEEN '".$form['camein']."' AND '".$form['camefi']."'";
        //recupero gli articoli in base alle scelte impostate
        $result = dynQuery ('*', $gTables['artico'], $where, $orderby);
        while ($a_row = dbms_fetch_array($result)) {
            $name_obj = 'pre'.strtolower($form['lisobj']);
            $name_base = 'pre'.strtolower($form['lisbas']);
            //calcolo il nuovo prezzo
            $new_price = compute_new_price($a_row[$name_base],$a_row[$name_obj],$form['valore'],$form['modali'],$form['arroto']);
            putRow($gTables['artico'],'codice',$a_row['codice'],$name_obj,$new_price);
        }
        header("Location:report_artico.php");
        exit;
        }

if (isset($_POST['Return']))
        {
        header("Location:report_artico.php");
        exit;
        }

require_once("../../library/include/header.php");
$strTrad = $strScript["update_prezzi.php"];
HeadMain(array(2,28));
echo "<form method=\"POST\">\n";
echo "<div align=\"center\" class=\"FacetFormHeaderFont\">".ucfirst($strTrad[0])."</div>\n";
echo "<table border=\"0\" cellpadding=\"3\" cellspacing=\"1\" class=\"FacetFormTABLE\" align=\"center\">\n";
if (!empty($msg)) {
    $message = "";
    $rsmsg = array_slice( explode('+',chop($msg)),0,-1);
    foreach ($rsmsg as $value){
            $message .= $strMessage['error']."! -> ";
            $rsval = explode('-',chop($value));
            foreach ($rsval as $valmsg){
                    $message .= $strTrad[$valmsg]." ";
            }
            $message .= "<br />";
    }
    echo '<tr><td colspan="5" class="FacetDataTDred">'.$message."</td></tr>\n";
}
echo "<tr><td class=\"FacetFieldCaptionTD\">".$strTrad[8]."</td>
     <td class=\"FacetDataTD\">\n";
echo "<select name=\"lisbas\" class=\"FacetSelect\" onchange=\"this.form.submit()\">\n";
$selArray = array('ACQ' => $strTrad[2],'VE1' => $strTrad[3].' 1','VE2' => $strTrad[3].' 2','VE3' => $strTrad[3].' 3');
        foreach ($selArray as $key => $value)
            {
            $selected="";
            if($form["lisbas"] == $key)
                $selected = " selected ";
            echo "<option value=\"".$key."\"".$selected.">".$value."</option>";
            }
echo "</select></td></tr>\n";
echo "<tr><td class=\"FacetFieldCaptionTD\">".$strTrad[4]."</td>
     <td class=\"FacetDataTD\">\n";
echo "<select name=\"camein\" class=\"FacetSelect\" onchange=\"this.form.submit()\">\n";
        $result = dynQuery("*", $gTables['catmer'],1,"codice asc");
        while ($a_row = dbms_fetch_array($result))
            {
            $selected = "";
            if($form["camein"] == $a_row["codice"])
                $selected = "selected";
            echo "\t\t <option value=\"".$a_row["codice"]."\" $selected >".$a_row["codice"]."-".$a_row["descri"]."</option>\n";
            }
echo "</select></td></tr>\n";
echo "<tr><td class=\"FacetFieldCaptionTD\">".$strTrad[5]."</td>
     <td class=\"FacetDataTD\">\n";
echo "<select name=\"camefi\" class=\"FacetSelect\" onchange=\"this.form.submit()\">\n";
        $result = dynQuery("*", $gTables['catmer'],1,"codice desc");
        while ($a_row = dbms_fetch_array($result))
            {
            $selected = "";
            if($form["camefi"] == $a_row["codice"])
                $selected = "selected";
            echo "\t\t <option value=\"".$a_row["codice"]."\" $selected >".$a_row["codice"]."-".$a_row["descri"]."</option>\n";
            }
echo "</select></td></tr>\n";
echo "<tr><td class=\"FacetFieldCaptionTD\">".$strTrad[6]."</td>";
echo "<td class=\"FacetDataTD\"><input type=\"text\" name=\"coarin\" value=\"".$form["coarin"]."\" maxlength=\"15\" size=\"15\" class=\"FacetInput\"></td>\n";
echo "</tr><tr>\n";
echo "<td class=\"FacetFieldCaptionTD\">".$strTrad[7]."</td>\n";
echo "<td class=\"FacetDataTD\"><input type=\"text\" name=\"coarfi\" value=\"".$form["coarfi"]."\" maxlength=\"15\" size=\"15\" class=\"FacetInput\"></td>\n";
echo "</tr>\n";
echo "<tr><td class=\"FacetFieldCaptionTD\">".$strTrad[1]."</td>
     <td class=\"FacetDataTD\">\n";
echo "<select name=\"lisobj\" class=\"FacetSelect\" onchange=\"this.form.submit()\">\n";
        foreach ($selArray as $key => $value)
            {
            $selected="";
            if($form["lisobj"] == $key)
                $selected = " selected ";
            echo "<option value=\"".$key."\"".$selected.">".$value."</option>";
            }
echo "</select></td></tr>\n";
echo "<tr><td class=\"FacetFieldCaptionTD\">".$strTrad[9]."</td>
     <td class=\"FacetDataTD\">\n";
echo "<select name=\"modali\" class=\"FacetSelect\" onchange=\"this.form.submit()\">\n";
$modArray = array('A' => $strTrad[10],
                  'B' => $strTrad[11],
                  'C' => $strTrad[12],
                  'D' => $strTrad[13],
                  'E' => $strTrad[14],
                  'F' => $strTrad[15]);
        foreach ($modArray as $key => $value)
            {
            $selected="";
            if($form["modali"] == $key)
                $selected = " selected ";
            echo "<option value=\"".$key."\"".$selected.">".$value."</option>";
            }
echo "</select></td></tr>\n";
echo "<tr><td class=\"FacetFieldCaptionTD\">".$strTrad[16]."</td>";
echo "<td class=\"FacetDataTD\"><input type=\"text\" name=\"valore\" value=\"".$form["valore"]."\" maxlength=\"15\" size=\"15\" class=\"FacetInput\"></td>\n";
echo "</tr>\n";
echo "<tr><td class=\"FacetFieldCaptionTD\">".$strTrad[17]."</td>
     <td class=\"FacetDataTD\">\n";
echo "<select name=\"arroto\" class=\"FacetSelect\" onchange=\"this.form.submit()\">\n";
$arrotoArray = array(0 => ' 1 '.$money[0],
                  1 => ' 10 '.$strTrad[19],
                  2 => ' 1 '.$strTrad[18],
                  3 => ' 1 '.$strTrad[20],
                  4 => ' 0,1 '.$strTrad[21],
                  5 => ' 0,01 '.$strTrad[21]
                  );
    for( $counter = 0; $counter <= $azienda['decimal_price']; $counter++ ) {
            $selected='';
            if ($form['arroto'] == $counter) {
               $selected = ' selected ';
            }
            echo "<option value=\"".$counter."\"".$selected.">".$arrotoArray[$counter]."</option>";
    }
echo "\t </select></td></tr>\n";
echo "<tr><td class=\"FacetFieldCaptionTD\"></td><td align=\"right\" colspan=\"4\"  class=\"FacetFooterTD\">
      <input type=\"submit\" name=\"Return\" value=\"".$strButton['return']."\">\n\t<input type=\"submit\" name=\"anteprima\" value=\"".$strButton['view']."!\"></td></tr>\n";
echo "</table>\n";
if (isset($form['anteprima']) and $msg == '') {
   //preparo la query al database
   if (empty ($form['coarfi']))
       $form['coarfi'] = 'zzzzzzzzzzzzzzz';
   $orderby = " catmer asc, codice asc";
   $where = "codice BETWEEN '".$form['coarin']."' AND '".$form['coarfi']."' AND catmer BETWEEN '".$form['camein']."' AND '".$form['camefi']."' ";
   //recupero gli articoli in base alle scelte impostate
   $result = dynQuery ('*', $gTables['artico'], $where, $orderby);
   $ctrlnum = dbms_num_rows($result);
   if ($ctrlnum) {
       echo "<div><center><b>".$strTrad[22].$selArray[$form['lisobj']]."</b></div>";
       echo "<table class=\"Tlarge\">";
       echo "<tr>";
       echo "<td class=\"FacetFieldCaptionTD\" align=\"center\">".$strTrad[23]."</td>";
       echo "<td class=\"FacetFieldCaptionTD\">".$strTrad[24]."</td>";
       echo "<td class=\"FacetFieldCaptionTD\">".$strTrad[25]."</td>";
       echo "<td class=\"FacetFieldCaptionTD\" align=\"center\">".$strTrad[26]."</td>";
       echo "<td class=\"FacetFieldCaptionTD\" align=\"center\">".$strTrad[27]."</td>";
       echo "<td class=\"FacetFieldCaptionTD\" align=\"center\">".$strTrad[28]."</td>";
       echo "</tr>";
       $ctrlcatmer = "";
       while ($a_row = dbms_fetch_array($result)) {
           echo "<tr>";
           if ($a_row['catmer'] <> $ctrlcatmer) {
               $catmer = getRow($gTables['catmer'],"codice",$a_row['catmer']);
               echo "<td  align=\"center\" style=\"color: brown;\">".$catmer["descri"]."</td>";
           } else {
               echo "<td class=\"FacetDataTD\" align=\"center\"></td>";
           }
           echo "<td class=\"FacetDataTD\">".$a_row["codice"]." &nbsp;</td>";
           echo "<td class=\"FacetDataTD\">".$a_row["descri"]." &nbsp;</td>";
           echo "<td class=\"FacetDataTD\">".$a_row["unimis"]." &nbsp;</td>";
           $name_obj = 'pre'.strtolower($form['lisobj']);
           $name_base = 'pre'.strtolower($form['lisbas']);
           //calcolo il nuovo prezzo
           $new_price = compute_new_price($a_row[$name_base],$a_row[$name_obj],$form['valore'],$form['modali'],$form['arroto']);
           echo "<td class=\"FacetDataTD\" align=\"right\">".number_format($a_row[$name_obj],$azienda['decimal_price'],',','.')." &nbsp;</td>";
           echo "<td class=\"FacetDataTD\" align=\"right\">".number_format($new_price,$azienda['decimal_price'],',','.')." &nbsp;\n</td>";
           echo "</tr>";
           $ctrlcatmer = $a_row['catmer'];
       }
       echo "<tr><td align=\"right\" colspan=\"6\"><input type=\"submit\" name=\"genera\" value=\"".$strButton['submit'].strtoupper($strMessage['update'])." !\" /></TD></TR>";
       echo "</table>";
       }
    }
?>
</form>
</body>
</html>